﻿package code{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	import flash.events.TimerEvent;
	import flash.events.Event;
	import flash.ui.Keyboard;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLVariables;
	import flash.net.URLLoaderDataFormat;
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	import flash.external.ExternalInterface;
	import flash.text.TextField;

	public class CalcExo extends MovieClip {
		public var options:Object;
		public var spTitre:SpTitre;
		public var spQuestion:SpQuestion;
		public var spInfo:SpInfo;
		public var spAnimation:MovieClip;
		public var spScore:SpScore;
		public var spResultat:SpResultat;
		public var spCorrection:SpCorrection;
		public var spOption:Sprite;
		public var btnCommencer:CalcSimpleButton;
		public var dateDebutExo:Date;
		public var tempsRealisationExo:String;
		public var btnValider:CalcSimpleButton;
		public var btnQuestionSuivante:CalcSimpleButton;
		public var btnSuite:CalcSimpleButton;
		public var btnRecommencer:CalcSimpleButton;
		public var btnExoSuivant:CalcSimpleButton;
		public var btnOptions:CalcSimpleButton;
		public var btnValiderOption:CalcSimpleButton;
		public var btnTesterOption:CalcSimpleButton;
		public var chronoExo:CalcTimer;
		public var chronoQuestion:CalcTimer;
		public var evaluer:Function;
		public var corriger:Function;
		public var indiceQuestion:uint;
		public var indiceEssai:uint;
		public var totalQuestion:uint;
		public var totalEssai:uint;
		public var totalReponse:uint;
		public var aListeners:Array;
		public var aCtrlOption:Array;
		public var info;
		public var score:uint;
		public var scorePremierEssai:uint;
		private var texteCommun:Object;
		private var texteExo:Object;
		private var retardateur:Timer;
		private var repLang:String;
		private var contexte:String;
		private var statut:String;
		private var evaluation:String;
		private var uid:int;
		private var seanceId:int;
		private var nomExo:String;
		private var saveScore:String;
		private var intitule:String;
		private var connexionServeur:Boolean;
		private var permettreRecommencer:Boolean;
		private var permettreExoSuivant:Boolean;
		private var tempsMillisecondes:uint;
		private var scoreLoader:URLLoader;
		private var loaderRetour:URLLoader;
		//private var alerte:spAlerte;
		//constructeur
		public function CalcExo() {
			indiceQuestion=0;
			indiceEssai=0;
			loaderInfo.parameters.contexte == undefined ? contexte= "standalone" : contexte = loaderInfo.parameters.contexte;
	
			if(contexte=="appli-calculatice" && loaderInfo.parameters.rep_langue == undefined)
			{
				repLang = "flash/lang/fr"
			}
			else if (loaderInfo.parameters.rep_langue == undefined)
			{
				repLang = "lang/fr";
			}
			else
			{
			 	repLang = loaderInfo.parameters.rep_langue;
			}
			
			loaderInfo.parameters.statut == undefined ? statut= "prof" : statut = loaderInfo.parameters.statut;
			loaderInfo.parameters.uid == undefined ? uid=0 : uid = loaderInfo.parameters.uid;
			loaderInfo.parameters.seanceId == undefined ? seanceId=0 : seanceId = loaderInfo.parameters.seanceId;
			loaderInfo.parameters.save_score == undefined ? saveScore="save" : saveScore = loaderInfo.parameters.save_score;
			loaderInfo.parameters.intitule == undefined ? intitule="" : intitule = loaderInfo.parameters.intitule;
			aListeners = new Array();
			//on dessine le fond
			dessinerFond();
			//on cree le masque
			creerMasque();
		}

		public function initFrame1() {
			//on charge les textes, qd ils sont chargés on cree les boutons on passe a l'image 2 
			var commonTextLoader:URLLoader=new URLLoader(new URLRequest(repLang+"/calculatice_commun_as3.txt"));
			commonTextLoader.addEventListener(Event.COMPLETE,gestionCommonTextLoader);
		}

		public function initFrame2():void {
			totalQuestion=options.totalQuestion;
			totalEssai=options.totalEssai;
			score=0;
			scorePremierEssai=0;
			totalReponse=0;
			//gestion appui touche Enter
			this.stage.addEventListener(KeyboardEvent.KEY_DOWN,gestionClavier);
			//on cree une instance unique de spTitre
			if (null==spTitre) {
				spTitre = new SpTitre();
			}
			
			//on affiche le bouton Commencer
			this.addChild(btnCommencer);
			btnCommencer.y=400;
			btnCommencer.x=(735-btnCommencer.width)/2;
			//on ajoute le bouton Options
			if(loaderInfo.parameters.contexte==undefined || loaderInfo.parameters.statut=="prof")
			{
				this.addChild(btnOptions);
				btnOptions.y=10;
				btnOptions.x=735-btnOptions.width-10;
			}
			//on cree le chrono de l'exercice ou de la question
			if (options.temps_exo>0) {
				if(null == chronoExo)
				{
					chronoExo=new CalcTimer(options.temps_exo);
					chronoExo.timer.addEventListener("timerComplete",gestionTimerComplete);
				}
				else
				{
					chronoExo.updateDuree(options.temps_exo);
				}
			} else if (options.temps_question > 0 ) {
				if(null == chronoQuestion)
				{
					chronoQuestion=new CalcTimer(options.temps_question);
					chronoQuestion.timer.addEventListener("timerComplete",gestionTimerComplete);
				}
				else
				{
					chronoQuestion.updateDuree(options.temps_question);
				}
			}
			
		}

		public function initFrame3():void {
			//on incrémente l'indice de la question (première question=1);
			indiceQuestion++;
			indiceEssai=1;
			
			//on cree la zone qui contiendra l'animation si elle n'existe pas
			if (null==spAnimation) {
				spAnimation = new MovieClip();
			}
			this.addChild(spAnimation);

			//on cree la zone qui contiendra la question si elle n'existe pas
			if (null==spQuestion) {
				spQuestion = new SpQuestion();
				
			}
			//this.addChild(spQuestion);
			spQuestion.indiceQuestion=indiceQuestion;
			//zone info
			if (null==spInfo) {
				spInfo = new SpInfo();
				
			}
			//zone score
			if (null==spScore) {
				spScore = new SpScore();
				
			}
			//zone correction
			if (null==spCorrection) {
				spCorrection = new SpCorrection();
			}
			
			//on affiche le bouton valider
			if(btnValider.x==0 && btnValider.y==0)
			{
				//valeurs par defaut si valeurs pas fixees dans le fal
				btnValider.y=400;
				btnValider.x=735-btnValider.width-75;
			}
			this.addChild(btnValider);
			if (indiceQuestion>1) {
				addChild(spScore);
			}
			
			//on ajoute le chrono si besoin
			if (options.temps_exo > 0) {
				addChild(chronoExo);
				if(indiceQuestion==1)
					chronoExo.timer.reset();
				chronoExo.timer.start();
			} else if (options.temps_question > 0) {
				addChild(chronoQuestion);
				chronoQuestion.timer.reset();
				chronoQuestion.timer.start();
			}
			
		}


		public function initFrame5():void {
			//on cree la zone qui contiendra les resultats si elle n'existe pas
			this.addChild(spResultat);
		}

		public function initFrame6() {
			aCtrlOption = new Array();
			if (null==spOption) {
				spOption = new SpOption();
			}
			this.addChild(spOption);

			this.addChild(btnValiderOption);


			//this.addChild(btnTesterOption);

			btnValiderOption.y=400;
			btnTesterOption.y=400;
			btnValiderOption.x = (735 - (btnValiderOption.width + 50 + btnTesterOption.width))/2;
			btnTesterOption.x=btnValiderOption.x+btnValiderOption.width+50;
		}

		//gestion de l'enchainement des questions en fonction 
		//- de la reponse de l'utilisateur
		//- de l'indice de la question en cours

		public function avancer() {
			evaluation=evaluer();
			if (evaluation=="rien") {
				//pas de reponse
				commenter(spInfo.msgRien,"bleu");
				if (spQuestion.aTfSaisie!=null&&spQuestion.aTfSaisie.length>0) {
					this.stage.focus=spQuestion.aTfSaisie[0];
				}
				return false;

			} else if (evaluation=="faux" && indiceEssai < totalEssai) {
				//faux mais encore un essai
				trace("faux encore un essai");
				commenter(spInfo.msgFaux,"rouge");
				indiceEssai++;
				return false;
			} else {
				
				//juste ou faux dernier essai
				if (options.temps_question>0) {
					chronoQuestion.timer.stop();
				}
				if (spQuestion.aTfSaisie!=null) {
					//on desactive les zones de saisie
					for (var i=0; i<spQuestion.aTfSaisie.length; i++) {
						spQuestion.aTfSaisie[i].type="dynamic";
						spQuestion.aTfSaisie[i].selectable=false;
					}
				}
				if (contains(btnValider)) {
					this.removeChild(btnValider);
				}
				//on supprime tous les ecouteurs d'evenement ajoutes avec registerListener
				for (var j=0; j<aListeners.length; j++) {
					//sauf celui qui permet d'afficher la question suivante !
					if(aListeners[j][2]!=afficherQuestionSuivante)
						aListeners[j][0].removeEventListener(aListeners[j][1],aListeners[j][2]);
				}
				//
				totalReponse++;
				//
				if (evaluation=="juste"&&indiceQuestion<totalQuestion) {
					//C'est juste et ce nest pas la derniere question
					trace("juste");
					if (options.temps_exo>0) {
						chronoExo.timer.stop();
					}
					score++;
					if (indiceEssai<totalEssai) {
						scorePremierEssai++;
					}
					if(!options.totalTentative){
						afficherScore(score,options.totalQuestion);
					} else {
						afficherScore(score,options.totalTentative);
					}
					
					commenter(spInfo.msgJuste,"vert");
					//afficherBtnQuestionSuivante();
					return "suivante";
				} else if (evaluation == "juste" && indiceQuestion == totalQuestion) {
					//C'est juste et c'est la derniere question
					trace("juste derniere question");
					if (options.temps_exo>0) {
						chronoExo.timer.stop();
					}
					score++;
					if (indiceEssai<totalEssai) {
						scorePremierEssai++;
					}
					if(!options.totalTentative){
						afficherScore(score,options.totalQuestion);
					} else {
						afficherScore(score,options.totalTentative);
					}
					commenter(spInfo.msgJusteFin);
					tempsRealisationExo=calculerTemps();
					//afficherBtnSuite();
					return "resultats";
				} else if (evaluation=="faux" && indiceQuestion < totalQuestion) {
					//c'est faux mais il reste des questions
					trace("faux");
					if (options.temps_exo>0) {
						chronoExo.timer.stop();
					}
					if(!options.totalTentative){
						afficherScore(score,options.totalQuestion);
					} else {
						afficherScore(score,options.totalTentative);
					}
					commenter(spInfo.msgFauxQuestionSuivante,"rouge");
					corriger();
					//afficherBtnQuestionSuivante();
					return "suivante"
				} else if (evaluation=="faux" && indiceQuestion == totalQuestion) {
					//Si c'est faux derniere question
					trace("faux derniere question");
					if (options.temps_exo>0) {
						chronoExo.timer.stop();
					}
					if(!options.totalTentative){
						afficherScore(score,options.totalQuestion);
					} else {
						afficherScore(score,options.totalTentative);
					}
					commenter(spInfo.msgFauxFin,"rouge");
					tempsRealisationExo=calculerTemps();
					corriger();
					//afficherBtnSuite();
					return "resultats"
				} else {
					//erreur de construction de la fonction evaluer
					trace("Erreur : La fonction evaluer doit renvoyer 'juste', 'faux' ou 'rien'");
					return false;
				}
			}
		}
		
		// utile pour les exos ou on ne veut pas utiliser le bouton suite
		public function poursuivreExercice(myDelayJuste:uint=0,myDelayFaux:uint=0):void {
			//on cree un objet timer pour avancerAuto
			if(myDelayFaux==0)
				myDelayFaux=myDelayJuste;
			if(null==retardateur)
			{
				retardateur = new Timer(myDelayJuste,1);
			}
			if(aListeners.indexOf([retardateur,"timer",afficherQuestionSuivante])<0)
			{
				registerListener(retardateur,"timer",afficherQuestionSuivante);
			}
			var res = avancer();
			if (res == "resultats")
			{
				afficherBtnSuite();
			}
			else if (res == "suivante")
			{
				if(evaluation=="juste")
				{
					retardateur.delay=myDelayJuste;
				}
				else if(evaluation=="faux")
				{
					retardateur.delay=myDelayFaux;
				}
				retardateur.start();
			}
		}
		
		// pour un exo style quadricalc
		// avec une seule question et plusieurs reponses
		// pas de retour sur l'image 3

		public function poursuivreQuestion() {
			evaluation=evaluer();
			if (evaluation=="rien") {
				//pas de reponse
				commenter(spInfo.msgRien,"bleu");
				//par defaut on cache les messages
				removeChild(spInfo);
				if (spQuestion.aTfSaisie!=null && spQuestion.aTfSaisie.length>0) {
					this.stage.focus=spQuestion.aTfSaisie[0];
				}
				return "rien";
			} else {
				//juste ou faux
				if (options.temps_question>0) {
					chronoQuestion.timer.stop();
				}
				if (spQuestion.aTfSaisie!=null) {
					//on desactive les zones de saisie
					for (var i=0; i<spQuestion.aTfSaisie.length; i++) {
						spQuestion.aTfSaisie[i].type="dynamic";
						spQuestion.aTfSaisie[i].selectable=false;
					}
				}
				if (contains(btnValider)) {
					this.removeChild(btnValider);
				}
				//
				totalReponse++;
				//
				if (evaluation=="juste") {
					trace("juste");
					score++;
					afficherScore(score,options.totalTentative);
					if(totalReponse < options.totalTentative)
					{
						return "juste";
					}
					else 
					{
						trace("juste exercice termine");
						//c'est juste l'exercice est fini
						//on supprime tous les ecouteurs d'evenement ajoutes avec registerListener
						for (var j=0; j<aListeners.length; j++) {
							aListeners[j][0].removeEventListener(aListeners[j][1],aListeners[j][2]);
						}
						if (options.temps_exo>0) {
							chronoExo.timer.stop();
						}
						if (indiceEssai<totalEssai) {
							scorePremierEssai++;
						}
						tempsRealisationExo=calculerTemps();
						
						afficherScore(score,options.totalTentative);
						
						commenter(spInfo.msgJusteFin);
						afficherBtnSuite();
						return false;
					}
				} else if (evaluation=="faux") {
					trace("faux");
					
					afficherScore(score,options.totalTentative);
					
					corriger();
					if(totalReponse < options.totalTentative)
					{
						return "faux";
					}
					else
					{
						//c'est faux l'exercice est fini
						trace("faux exercice termine");
						//c'est faux l'exercice est fini
						//on supprime tous les ecouteurs d'evenement ajoutes avec registerListener
						for (var k=0; j<aListeners.length; k++) {
							aListeners[k][0].removeEventListener(aListeners[k][1],aListeners[k][2]);
						}
						if (options.temps_exo>0) {
							chronoExo.timer.stop();
						}
						if (indiceEssai<totalEssai) {
							scorePremierEssai++;
						}
						tempsRealisationExo=calculerTemps();
						
						afficherScore(score,options.totalTentative);
					
						commenter(spInfo.msgFauxFin,"rouge");
						afficherBtnSuite();
						return false;
					}
				} else {
					//erreur de construction de la fonction evaluer
					trace("Erreur : La fonction evaluer doit renvoyer 'juste', 'faux' ou 'rien'");
					return "erreur";
				}
			}
		}
		
		public function terminerExercice()
		{
			//on supprime tous les ecouteurs d'evenement ajoutes avec registerListener
			for (var j=0; j<aListeners.length; j++) {
				aListeners[j][0].removeEventListener(aListeners[j][1],aListeners[j][2]);
			}
			if (options.temps_exo>0) {
				chronoExo.timer.stop();
			}
			if (indiceEssai<totalEssai) {
				scorePremierEssai++;
			}
			tempsRealisationExo=calculerTemps();
			if(!options.totalTentative){
				afficherScore(score,options.totalQuestion);
			} else {
				afficherScore(score,options.totalTentative);
			}
			commenter(spInfo.msgFin,"bleu");
			afficherBtnSuite();
		}
		//Reference un ecouteur dans un tableau (pour pouvoir le detruire fcilement ensuite)
		public function registerListener(dispObj,eventName:String,fonction:Function) {
			dispObj.addEventListener(eventName,fonction,false,0,true);
			aListeners.push(new Array(dispObj,eventName,fonction));
		}
		public function unregisterListener(dispObj,eventName:String,fonction:Function) {
			dispObj.removeEventListener(eventName,fonction);
			var index=aListeners.indexOf(new Array(dispObj,eventName,fonction));
			aListeners.splice(index,1);
		}
		//affiche le score
		public function afficherScore(point:uint,total:uint) {
			spScore.tfScore.text="Score : "+point+" sur "+total;
			addChild(spScore);
		}
		//
		public function commenter(msg:String,codeCouleur:String="bleu"):void {
			if (! contains(spInfo)) {
				addChild(spInfo);
			}
			spInfo.ajouterInfo(msg,codeCouleur);
			
			if(spInfo.positionAuto)
			{
			
				//valeurs par defaut si pas fixees dans le fla
				if (contains(btnSuite)) {
					spInfo.x=btnSuite.x + (btnSuite.width-spInfo.width)/2;
					spInfo.y=btnSuite.y-spInfo.height-10;
				} else if (contains(btnQuestionSuivante)) {
					spInfo.x=btnQuestionSuivante.x + (btnQuestionSuivante.width-spInfo.width)/2;
					spInfo.y=btnQuestionSuivante.y-spInfo.height-10;
				} else if ( contains(btnValider)) {
					spInfo.x=btnValider.x + (btnValider.width-spInfo.width)/2;
					spInfo.y=btnValider.y-spInfo.height-10;
				} else if (msg == spInfo.msgRien) {
					spInfo.x=btnValider.x + (btnValider.width-spInfo.width)/2;
					spInfo.y=btnValider.y-spInfo.height-10;
				} else {
					spInfo.x = 735 - spInfo.width -20;
					spInfo.y = 450 - spInfo.height -60;
				}
			}
		}
		//
		public function calculerTemps():String {
			var dateFinExo = new Date();
			var timeStampDebut=dateDebutExo.getTime();
			var timeStampFin=dateFinExo.getTime();
			tempsMillisecondes = timeStampFin - timeStampDebut;
			var dif = Math.round((timeStampFin - timeStampDebut)/1000);
			var minutes = (dif - (dif % 60))/60;
			var secondes=dif%60;
			var min=" minute";
			var sec=" seconde";
			if (minutes>1) {
				min+="s";
			}
			if (secondes>1) {
				sec+="s";
			}
			return "" + minutes + min +" et " + secondes + sec;
		}
		//
		public function corrigerAuto(sCorrection:String,sAlignement:String):void {
			if (! contains(spCorrection)) {
				addChild(spCorrection);
			}
			spCorrection.ajouterCorrection(sCorrection);
			switch (sAlignement) {
				case "droite" :
					spCorrection.x=spQuestion.x+spQuestion.aTfSaisie[0].x+spQuestion.aTfSaisie[0].width+5;
					spCorrection.y = spQuestion.y+spQuestion.aTfSaisie[0].y-((spCorrection.height-spQuestion.aTfSaisie[0].height)/2);
					break;
				case "bas" :
					spCorrection.x=spQuestion.x+spQuestion.aTfSaisie[0].x+(spQuestion.aTfSaisie[0].width-spCorrection.width)/2;
					spCorrection.y = spQuestion.y+spQuestion.aTfSaisie[0].y+spQuestion.aTfSaisie[0].height+5;
					break;
				case "haut" :
					spCorrection.x=spQuestion.x+spQuestion.aTfSaisie[0].x+(spQuestion.aTfSaisie[0].width-spCorrection.width)/2;
					spCorrection.y = spQuestion.y+spQuestion.aTfSaisie[0].y-spCorrection.height-5;
					break;
			}
			//on barre la reponse de l'eleve
			var shRature = new Shape();
			shRature.graphics.moveTo(0,0)
			shRature.graphics.lineStyle(5, 0xF50000, 0.5);
			//spQuestion.graphics.beginFill(0xFF402B);
			shRature.graphics.lineTo(spQuestion.aTfSaisie[0].width - 20,spQuestion.aTfSaisie[0].height- 10);
			shRature.graphics.moveTo(0,shRature.height-5);
			shRature.graphics.lineTo(shRature.width-5,0);
			spQuestion.addChild(shRature);
			shRature.x = spQuestion.aTfSaisie[0].x+10;
			shRature.y = spQuestion.aTfSaisie[0].y+5;

		}



		//utilitaires

		//retourne un tableau de nombres à partir d'un string 
		//du type  "min-max" ou "n1;n2;n3;n4" ou "n" ou min,max n sont des nombes
		//utile pour parametrer des plages numeriques
		public function getArrayNombres(sOption:String):Array {
			var aNombre = new Array();
			var aNombreTemp =new Array();
			if (sOption.indexOf(";")>0) {
				//une serie de nombres
				aNombreTemp=sOption.split(";");
				aNombreTemp.forEach(function(elem){aNombre.push(Number(elem))});
			} else if (sOption.indexOf("-") > 0) {
				//une plage de nombres
				var aRange:Array=sOption.split("-");
				for (var j=Number(aRange[0]); j<=Number(aRange[1]); j++) {
					aNombre.push(Number(j));
				}
			} else {
				//un nombre seul
				aNombre.push(Number(sOption));
			}
			return aNombre;
		}
		//
		private function dessinerFond() {
			var hauteur_totale=450;
			var largeur_totale=735;
			for (var i = 0; i<=hauteur_totale/4; i++) {
				var j=4*i;
				with (this.graphics) {
					lineStyle(1, "0xFFFFFF", 100);
				moveTo(0, j);
				lineTo(largeur_totale, j);
				lineStyle(1, "0xF6F6F5", 100);
				moveTo(0, j+1);
				lineTo(largeur_totale, j+1);
				lineStyle(1, "0xF0F0F0", 100);
				moveTo(0, j+2);
				lineTo(largeur_totale, j+2);
				lineStyle(1, "0xF4F4F3", 100);
				moveTo(0, j+3);
				lineTo(largeur_totale, j+3);
				}
			}
		}



		//Creation affichage du bouton Question suivante
		private function afficherBtnQuestionSuivante() {
			//on affiche le bouton question suivante
			if (! this.contains(btnQuestionSuivante)) {
				if(btnQuestionSuivante.x == 0 && btnQuestionSuivante.y == 0)
				{
					//valeurs par defaut si pas fixees dans le fla
					btnQuestionSuivante.y=400;
					btnQuestionSuivante.x=735-btnQuestionSuivante.width-75;
				}
				this.addChild(btnQuestionSuivante);
			}
		}

		//Creation affichage du bouton suite
		//enregistrement des resultats
		private function afficherBtnSuite() {
			//on l'affiche le bouton suite
			if (! this.contains(btnSuite)) {
				if(btnSuite.x == 0 && btnSuite.y == 0)
				{
					//valeurs par defaut si pas fixees dans le fla
					btnSuite.y=400;
					btnSuite.x=735-btnSuite.width-75;
				}
				this.addChild(btnSuite);
			}
			//on prepare le sprite resultats qu'on affichera en frame5
			if (null==spResultat) {
				spResultat = new SpResultat();
			}
			if(!options.totalTentative)
			{
				totalReponse = options.totalQuestion;
			}
			else {
				totalReponse = options.totalTentative;
			}
			if (options.totalEssai>1) {
				spResultat.ajouterScore(score,scorePremierEssai,totalReponse,tempsRealisationExo,true);
			} else {
				spResultat.ajouterScore(score,scorePremierEssai,totalReponse,tempsRealisationExo,false);
			}
			//on envoie les resultats au serveur selon le contexte
			if (
				contexte=="LaboMEP"
				|| (contexte == "appli-calculatice" && statut=="eleve" && "nosave"!=saveScore)
				|| (contexte=="calculatice-flex" && statut != "prof")
				|| contexte == "rallye"
				|| contexte == "acces-libre"
				)
			{
				enregistrerResultat();
			}
			else
			{
				ajouterBtnRecommencer()
			}
		}
		
		//Affichage du bouton Recommencer
		private function ajouterBtnRecommencer() {
			if (! spResultat.contains(btnRecommencer)) {
				spResultat.addChild(btnRecommencer);
				btnRecommencer.y = 200;
				btnRecommencer.x = (spResultat.width - btnRecommencer.width)/2;
			}
		}
		
		//Affichage du bouton Exo Suivant
		private function ajouterBtnExoSuivant() {
			if (! spResultat.contains(btnExoSuivant)) {
				spResultat.addChild(btnExoSuivant);
				btnExoSuivant.y = 200;
				btnExoSuivant.x = (spResultat.width - btnExoSuivant.width)/2;
			}
		}

		//Gestion du clic sur Commencer
		private function gestionClickCommencer(evt:MouseEvent) {
			//on supprime tous les ecouteurs d'evenement ajoutes avec registerListener
			for (var i=0; i<aListeners.length; i++) {
				aListeners[i][0].removeEventListener(aListeners[i][1],aListeners[i][2]);
			}
			if (contains(spTitre)) {
				removeChild(spTitre);
				spTitre=null;
			}
			this.removeChild(btnCommencer);
			if (contains(btnOptions)) {
				removeChild(btnOptions);
			}
			//on demarre le calcul du temps mis pour faire l'exo;
			dateDebutExo = new Date();
			this.gotoAndPlay(3);
		}

		//Gestion du clic sur Options
		private function gestionClickOptions(evt:MouseEvent) {
			//on supprime tous les ecouteurs d'evenement ajoutes avec registerListener
			for (var i=0; i<aListeners.length; i++) {
				aListeners[i][0].removeEventListener(aListeners[i][1],aListeners[i][2]);
			}
			if(contains(spTitre))
			{
				removeChild(spTitre);
				spTitre=null;
			}
			this.removeChild(btnCommencer);
			this.removeChild(btnOptions);
			this.gotoAndPlay(6);
		}

		//gestion du clic sur Valider
		private function gestionClickValider(evt:MouseEvent) {
			validerReponse();
		}
		
		public function validerReponse():void
		{
			var res = avancer();
			if (res =="suivante")
			{
				afficherBtnQuestionSuivante();
			}
			else if(res =="resultats")
			{
				afficherBtnSuite();
			}
		}

		//gestion du clic sur Question suivante
		private function gestionClickQuestionSuivante(evt:MouseEvent) {
			afficherQuestionSuivante();
		}

		private function afficherQuestionSuivante(evt=null) {
			if(null!= retardateur)
			{
				retardateur.reset();
			}
			if (contains(spQuestion)) {
				removeChild(spQuestion);
			}
			if (contains(spInfo)) {
				this.removeChild(spInfo);
			}
			if (contains(spCorrection)) {
				this.removeChild(spCorrection);
			}
			if (contains(btnQuestionSuivante))
			{
				this.removeChild(btnQuestionSuivante);
			}
			this.removeChild(spAnimation);
			if (options.temps_question>0) {
				this.removeChild(chronoQuestion);
			}
			spAnimation=null;
			this.gotoAndPlay(3);
		}

		//gestion du clic sur "Resultats"
		private function gestionClickSuite(evt:MouseEvent) {
			trace("click btnSuite");
			afficherSuite();
		}
		//
		public function afficherSuite(delay:uint=0) {
			//spQuestion.vider();
			if (this.contains(spInfo)) {
				this.removeChild(spInfo);
			}
			if (this.contains(spQuestion)) {
				this.removeChild(spQuestion);
			}
			if (this.contains(btnSuite)) {
				this.removeChild(btnSuite);
			}
			if (this.contains(spAnimation)) {
				this.removeChild(spAnimation);
			}
			if (this.contains(spScore)) {
				this.removeChild(spScore);
			}
			if (contains(spCorrection)) {
				this.removeChild(spCorrection);
			}
			if (options.temps_exo>0) {
				this.removeChild(chronoExo);
			} else if (options.temps_question > 0) {
				this.removeChild(chronoQuestion);
			}
			spAnimation=null;
			
			this.gotoAndPlay(5);
		}

		//gestion du clic sur Recommencer
		private function gestionClickRecommencer(evt:MouseEvent) {
			spResultat.removeChild(btnRecommencer);
			this.removeChild(spResultat);
			indiceQuestion=0;
			this.gotoAndPlay(2);
		}
		
		//gestion du clic sur Suivant
		private function gestionClickExoSuivant(evt:MouseEvent) {
			spResultat.removeChild(btnExoSuivant);
			if (ExternalInterface.available)
			{
				ExternalInterface.call("exo_suivant");
			}
		}

		//gestion du clic sur Valider Options
		private function gestionClickValiderOption(evt:MouseEvent) {
			for (var i = 0; i< aCtrlOption.length; i++) {
				options[aCtrlOption[i].nom]=aCtrlOption[i].getCtrlOptionValue();
			}
			addChild(btnTesterOption);
			sendOptions(loaderInfo.parameters.contexte);
		}

		//gestion du clic sur Tester Options
		private function gestionClickTesterOption(evt:MouseEvent) {
			for (var i=0; i < aCtrlOption.length; i++) {
				options[aCtrlOption[i].nom]=aCtrlOption[i].getCtrlOptionValue();
				spOption.removeChild(aCtrlOption[i]);
				aCtrlOption[i]=null;
			}
			removeChild(spOption);
			removeChild(btnValiderOption);
			removeChild(btnTesterOption);
			gotoAndPlay(2);
		}

		//Gestion des raccourcis clavier
		private function gestionClavier(event:KeyboardEvent):void {
			if (event.keyCode==Keyboard.ENTER) {
				if (this.contains(btnCommencer)) {
					btnCommencer.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				} else if (this.contains(btnValider)) {
					btnValider.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				} else if (this.contains(btnQuestionSuivante) && btnQuestionSuivante.enabled) {
					btnQuestionSuivante.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				} else if (this.contains(btnSuite) && btnSuite.enabled) {
					btnSuite.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				} else if (this.contains(btnRecommencer)) {
					btnRecommencer.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
				}
			}
		}
		//
		private function gestionTimerComplete(evt:TimerEvent) {
			trace("timerComplete");
			var i,j,k:uint;
			if (options.temps_exo>0) {
				chronoExo.barre.width=0;
				//on desactive les zones de saisie
				if (contains(spQuestion)) {
					for (i=0; i<spQuestion.aTfSaisie.length; i++) {
						spQuestion.aTfSaisie[i].type="dynamic";
						spQuestion.aTfSaisie[i].selectable=false;
					}
				}
				if (contains(btnValider)) {
					this.removeChild(btnValider);
				}
				if (contains(btnQuestionSuivante)) {
					this.removeChild(btnQuestionSuivante);
				}
				//on supprime tous les ecouteurs d'evenement ajoutes avec registerListener
				for (j=0; j<aListeners.length; j++) {
					aListeners[j][0].removeEventListener(aListeners[j][1],aListeners[j][2]);
				}
				tempsRealisationExo=calculerTemps();
				if(!options.totalTentative){
					afficherScore(score,options.totalQuestion);
				} else {
					afficherScore(score,options.totalTentative);
				}
				afficherBtnSuite();
				commenter(spInfo.msgTempsExoDepasse,"rouge");
				corriger();
			} else if (options.temps_question > 0) {
				chronoQuestion.barre.width=0;
				//on desactive les zones de saisie
				if (contains(spQuestion)) {
					for (k=0; k<spQuestion.aTfSaisie.length; k++) {
						spQuestion.aTfSaisie[k].type="dynamic";
						spQuestion.aTfSaisie[k].selectable=false;
					}
				}
				if (contains(btnValider)) {
					this.removeChild(btnValider);
				}
				//on supprime tous les ecouteurs d'evenement ajoutes avec registerListener
				//!sauf celui qui permet de passer à la question suivante !
				for (j=0; j<aListeners.length; j++) {
					if(aListeners[j][2]!=afficherQuestionSuivante)
						aListeners[j][0].removeEventListener(aListeners[j][1],aListeners[j][2]);
				}
				if(!options.totalTentative){
					afficherScore(score,options.totalQuestion);
				} else {
					afficherScore(score,options.totalTentative);
				}
				if (indiceQuestion<totalQuestion) {
					trace(spInfo.msgTempsQuestionDepasse);
					afficherBtnQuestionSuivante();
				} else {
					tempsRealisationExo=calculerTemps();
					afficherBtnSuite();
				}
				commenter(spInfo.msgTempsQuestionDepasse,"rouge");
				corriger();
			}
		}

		private function gestionCommonTextLoader(evt:Event) {
			var loader2:URLLoader=URLLoader(evt.target);
			var textData=loader2.data;
			var regExp:RegExp=/[\r*\n]/g;
			var textDataArray:Array=textData.split(regExp);
			texteCommun=new Object  ;
			for (var i = 0; i<textDataArray.length; i++) {
				if (textDataArray[i].charAt(0)=="p") {
					var tempArray=textDataArray[i].split("=");
					var cle=tempArray[0].replace(" ",'');
					var valeur=tempArray[1];
					texteCommun[cle]=valeur;
				}
			}
			var exoTextLoader:URLLoader=new URLLoader(new URLRequest(repLang+"/"+options.nom+".txt"));
			exoTextLoader.addEventListener(Event.COMPLETE,gestionExoTextLoader);
			//on charge les options
			loadOptions(loaderInfo.parameters.contexte);
		}

		private function gestionExoTextLoader(evt:Event) {
			var loader3:URLLoader=URLLoader(evt.target);
			var textData=loader3.data;
			var regExp:RegExp=/[\r*\n]/g;
			var textDataArray:Array=textData.split(regExp);
			texteExo=new Object;
			for (var i = 0; i<textDataArray.length; i++) {
				if (textDataArray[i].charAt(0)=="p") {
					/*
					var tempArray=textDataArray[i].split("=");
					var cle=tempArray[0].replace(" ",'');
					var valeur=tempArray[1];
					*/
					var cle = textDataArray[i].substring(0,textDataArray[i].indexOf("=")).replace(" ","");
					var valeur = textDataArray[i].substring(textDataArray[i].indexOf("=")+1)
					var search:RegExp=/\\r/g;
					valeur = valeur.replace(search,function(){ return "\r"});
					texteExo[cle]=valeur;
				}
			}
			
			//on cree les boutons
			btnCommencer=new CalcSimpleButton(texteCommun.p1_1);
			btnCommencer.addEventListener(MouseEvent.CLICK,gestionClickCommencer);
			//
			btnOptions=new CalcSimpleButton(texteCommun.p1_2);
			btnOptions.addEventListener(MouseEvent.CLICK,gestionClickOptions);
			//
			btnValider=new CalcSimpleButton(texteCommun.p1_3);
			btnValider.addEventListener(MouseEvent.CLICK,gestionClickValider);
			
			//
			btnQuestionSuivante=new CalcSimpleButton(texteCommun.p1_4);
			btnQuestionSuivante.addEventListener(MouseEvent.CLICK,gestionClickQuestionSuivante);
			
			//
			btnSuite=new CalcSimpleButton(texteCommun.p1_5);
			btnSuite.addEventListener(MouseEvent.CLICK,gestionClickSuite);
			
			//
			btnRecommencer=new CalcSimpleButton(texteCommun.p1_6);
			btnRecommencer.addEventListener(MouseEvent.CLICK,gestionClickRecommencer);
			//
			btnExoSuivant=new CalcSimpleButton(texteCommun.p1_9);
			btnExoSuivant.addEventListener(MouseEvent.CLICK,gestionClickExoSuivant);
			//
			btnTesterOption=new CalcSimpleButton(texteCommun.p1_8);
			btnTesterOption.addEventListener(MouseEvent.CLICK,gestionClickTesterOption);
			//
			btnValiderOption=new CalcSimpleButton(texteCommun.p1_7);
			btnValiderOption.addEventListener(MouseEvent.CLICK,gestionClickValiderOption);

			gotoAndPlay(2);
		}
		
		private function loadOptions(sContexte) {
			var parametres:String;
			if (sContexte == "appli-calculatice" || sContexte == "calculatice-flex") 
			{
				if (ExternalInterface.available)
				{
					parametres=ExternalInterface.call("charger_options");
					if(parametres !="default")
					{
						options = JSON.decode(parametres);
					}
				}
			}
		}
		//
		private function sendOptions(sContexte)
		{
			trace("sendOptions");
			//var ret = ExternalInterface.call("enregistrer_options",options);
			if (sContexte == "appli-calculatice" || sContexte == "calculatice-flex") 
			{
				if (ExternalInterface.available)
				{
					var sOptions = JSON.encode(options);
					var ret = ExternalInterface.call("enregistrer_options",sOptions);
				}
				
			}
		}
		//
		//enregistre les resultats une fois l'exercice terminé et affiche le bouton "Recommencer" ou "Suivant"
		private  function enregistrerResultat() {
			//Enregistrement des resultats
			var dataToSend:URLVariables = new URLVariables();
			var requete:URLRequest = new URLRequest();
			requete.method = "POST";
			scoreLoader = new URLLoader();
			//scoreLoader.addEventListener(HTTPStatusEvent.HTTP_STATUS  , alerterDeconnexion);
			scoreLoader.addEventListener(Event.COMPLETE, gestionRetourEnregistrement);
			
			//on renvoie tous les parametres qui ont ete passes
			//dans l'url de l'exo
			for (var prop in loaderInfo.parameters) { 
				//trace("myObject."+prop+" = "+myObject[prop]); 
				dataToSend[prop]=loaderInfo.parameters[prop];
			}
			if(contexte=="LaboMEP")
			{
		
				//routine 1 particuliere à mep
				var mepData={};
				mepData.uid=this.uid;//identifiant passé dans l'url du flash
				mepData.score=score;//le score de reussite
				mepData.nbre_questions=totalReponse;//le nombre de questions
				mepData.temps=tempsMillisecondes//le temps mis pour faire l'exercice
				//this.ClipMep._level0.commphp(mepData);
				permettreRecommencer=true;
			
			}
			else if (contexte=="appli-calculatice")
			{
				dataToSend.contexte_exo= dataToSend.contexte ///necessaire pour compatiblite avec ancien modele
				dataToSend.action="ele_resultat"
				dataToSend.action_secondaire="save_score"
				dataToSend.nom_exo=options.nom
				dataToSend.score_exo = score;
				if(!options.totalTentative){
					dataToSend.nbre_questions_exo = options.totalQuestion;
				} else {
					dataToSend.nbre_questions_exo = options.totalTentative;
				}
				
				dataToSend.temps_exo=tempsMillisecondes;
				requete.url = "main.php";
				requete.data = dataToSend;
				try
				{
					scoreLoader.load(requete);
				}
				catch (error:Error) {
					alerterDeconnexion();
				}
				
			}
			else if (contexte=="rallye")
			{
				dataToSend.action="rallye"
				dataToSend.action_secondaire="save_score"
				dataToSend.nom_exo=options.nom
				dataToSend.score_exo = score;
				if(!options.totalTentative){
					dataToSend.nbre_questions_exo = options.totalQuestion;
				} else {
					dataToSend.nbre_questions_exo = options.totalTentative;
				}
				dataToSend.temps_exo=tempsMillisecondes;
				requete.url = "main.php";
				requete.data = dataToSend;
				connexionServeur = true;
				try
				{
					scoreLoader.load(requete);
				}
				catch (error:Error) {
					alerterDeconnexion();
				}
			}
		}
		//
		private function gestionRetourEnregistrement(evt):void
		{
			
			var loaderRetour:URLLoader = URLLoader(evt.target);
			var dataReceived;
			if(contexte=="LaboMEP")
			{
				//routine 2 particulière à mep pour gérer le bouton suivant
			} 
			else if(contexte=="rallye")
			{
				dataReceived = XML(loaderRetour.data);
				if(dataReceived.enregistrement=="ok")
				{
					ajouterBtnExoSuivant();
				}
				else
				{
					alerterErreurEnregistrement();
				}
			} 
			else 
			{
				dataReceived = new URLVariables(loaderRetour.data);
				if(dataReceived.enregistrement=="ok")
				{
					ajouterBtnRecommencer();
					if(dataReceived.permettre_suivant=="oui")
					{
						ajouterBtnExoSuivant();
					}
					if(spResultat.contains(btnRecommencer) && spResultat.contains(btnExoSuivant))
					{
						btnRecommencer.x = (spResultat.width - btnRecommencer.width - btnExoSuivant.width - 40)/2;
						btnExoSuivant.x = btnRecommencer.x + btnRecommencer.width + 40;
					}
				}
				else
				{
					alerterErreurEnregistrement()
				}
			}
		}
		//
		private function alerterDeconnexion()
		{
			var alerte = new SpAlerte("Vous avez été deconnecté.\nVeuillez vous reconnecter.");
			alerte.btnValider.addEventListener("click",gestionDeconnexion);
			addChild(alerte);
		}
		//
		private function alerterErreurEnregistrement()
		{
			var alerte = new SpAlerte("Erreur d'enregistrement des résultats\nVeuillez vous reconnecter.");
			alerte.btnValider.addEventListener("click",gestionDeconnexion);
			addChild(alerte);
		}
		//
		private function gestionDeconnexion(evt)
		{
			trace(evt.currentTarget.parent);
			if (flash.external.ExternalInterface.available)
			{
				flash.external.ExternalInterface.call("deconnecter");
				evt.currentTarget.removeEventListener("click",gestionDeconnexion);
			}
			removeChild(evt.currentTarget.parent);
			
		}
		//
		private function creerMasque():void
		{
			var square:Sprite = new Sprite();
			square.graphics.beginFill(0xff0000); 
			square.graphics.drawRect(0, 0, 735, 450); 
			square.graphics.endFill();
			addChild(square);
			this.mask = square;
		}
	}
}