﻿package code
{
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	
	
	public class CalcSimpleButton extends SimpleButton
	{
		public var etatNormal:Sprite;
		public var etatSurvol:Sprite;
		public var etatClic:Sprite;
		
		
		public function CalcSimpleButton(texte:String)
		{
			etatNormal = new EtatBouton(0xCCCCCC,0xEEEEEE,14,texte);
			etatSurvol = new EtatBouton(0x999999,0xD9DBDB,14,texte);
			etatClic =  new EtatBouton(0xCCCCCC,0xEEEEEE,14,texte);
			this.upState = etatNormal;
			this.overState = etatSurvol;
			this.downState = etatNormal;
			this.hitTestState = etatNormal;
		}
	}
}

import flash.display.Sprite;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import code.CalcTextFormat;
import code.CalcTextField;
import flash.display.GradientType;
import flash.geom.Matrix;

internal class EtatBouton extends Sprite
{
	public function EtatBouton(couleurTrait:uint,couleurFond:uint,taillePolice:uint,texte:String)
	{
		var tfEtiquette:CalcTextField = new CalcTextField();
		tfEtiquette.wordWrap=false;
		tfEtiquette.textFormat.size=14;
		tfEtiquette.textFormat.leading=0;
		//tfEtiquette.textFormat.ajouteGras();
		tfEtiquette.autoSize= TextFieldAutoSize.CENTER;
		tfEtiquette.defaultTextFormat = tfEtiquette.textFormat;
		tfEtiquette.text=texte;
		this.addChild(tfEtiquette);
		tfEtiquette.x=0;
		tfEtiquette.y=0;
		
		
		var gradientBoxMatrix:Matrix = new Matrix();
		gradientBoxMatrix.createGradientBox(tfEtiquette.width+10, tfEtiquette.height+10, Math.PI/2, 0, 0);
		this.graphics.lineStyle(1, couleurTrait, 1);
		this.graphics.beginGradientFill(GradientType.LINEAR, [0xFFFFFF, couleurFond], [1,0.5], [0,255], gradientBoxMatrix);
		this.graphics.drawRoundRect(0, 0, tfEtiquette.width+10, tfEtiquette.height+10,10);
		
		tfEtiquette.x=((this.width-2)-tfEtiquette.width)/2
		tfEtiquette.y=((this.height-2)-tfEtiquette.height)/2
	}
}