﻿package code
{
    import flash.utils.Timer;
    import flash.events.TimerEvent;
	import flash.events.Event;
    import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.GradientType;
	import flash.geom.Matrix;
	

    public class CalcTimer extends Sprite 
	{
		public var timer:Timer;
		public var duree:uint;
		public var fond:Shape;
		public var barre:Shape;

        public function CalcTimer(dureeEnSecondes) 
		{
			duree = dureeEnSecondes;
            timer = new Timer(1000, duree);
            
			//
			fond = new Shape();
			barre = new Shape();
			//fond.width = 735;
			//fond.height = 10;
			
			timer.addEventListener("timer", gestionTimer);
			addEventListener(Event.ADDED_TO_STAGE,dessinerChrono);
        }
		
		public function updateDuree(dureeEnSecondes)
		{
			duree = dureeEnSecondes;
			timer.repeatCount=duree;
		}

        private function gestionTimer(evt:TimerEvent):void 
		{
			barre.width -= 735/duree;
        }
		
		private function dessinerChrono(evt:Event)
		{
			fond.graphics.clear();
			barre.graphics.clear();
			fond.graphics.beginFill(0xDD3729);
			fond.graphics.drawRect(0,0,735,10);
			barre.graphics.beginFill(0x0099CC);
			barre.graphics.drawRect(0,0,735,10);
			barre.width = 735;
			//colorier(barre,0x0099CC,0x0099CC);
			addChild(fond);
			addChild(barre);
			
		}
		//
		private function colorier(target,couleurTrait,couleurFond):void
		{
			target.graphics.clear();
			var gradientBoxMatrix:Matrix = new Matrix();
			gradientBoxMatrix.createGradientBox(target.width, target.height, Math.PI/2, 0, 0);
			target.graphics.lineStyle(3, couleurTrait, 1);
			target.graphics.beginGradientFill(GradientType.LINEAR, [couleurFond, couleurFond], [1,1], [0,255], gradientBoxMatrix);
			target.graphics.drawRoundRect(0, 0, target.width, target.height,10);
			
		}
		
    }
}