﻿package code
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.display.GradientType;
	import flash.geom.Matrix;
	
	
	public class SpInfo extends Sprite
	{
		public var tfInfo:CalcTextField;
		public var largeur:Number;
		public var padding:Number;
		public var msgJuste:String;
		public var msgJusteFin:String;
		public var msgFaux:String;
		public var msgFauxQuestionSuivante:String;
		public var msgFauxFin:String;
		public var msgFin:String;
		public var msgRien:String;
		public var msgTempsExoDepasse:String;
		public var msgTempsQuestionDepasse:String;
		public var positionAuto:Boolean;
		
		public function SpInfo()
		{
			
			msgJuste = "Bravo ! ";
			msgJusteFin = "Bravo ! Exercice terminé. ";
			msgFaux = "Faux mais tu as encore un essai.";
			msgFauxQuestionSuivante = "Faux. Regarde la correction.";
			msgFauxFin = "Faux. Exercice terminé.";
			msgFin = "Exercice terminé";
			msgRien = "Tu n'as pas donné de réponse.";
			msgTempsExoDepasse = "Temps dépassé !";
			msgTempsQuestionDepasse = "Temps dépassé !";
			
			padding=10;
			largeur=150;
			positionAuto = true;
		}
		
		public function ajouterInfo(texte:String,codeCouleur:String="bleu")
		{
			if(null==tfInfo)
			{
				tfInfo = new CalcTextField();
			}
			tfInfo.width = largeur;
			tfInfo.wordWrap = true;
			tfInfo.autoSize= TextFieldAutoSize.CENTER;
			tfInfo.textFormat.ajouteGras();
			tfInfo.textFormat.size=12;
			tfInfo.textFormat.color=0xFFFFFF;
			tfInfo.textFormat.leading=0;
			tfInfo.textFormat.align="center";
			tfInfo.defaultTextFormat=tfInfo.textFormat;
			tfInfo.text=texte;
			tfInfo.x=padding;
			tfInfo.y=padding;
			dessinerFond(codeCouleur);
			if(!this.contains(tfInfo))
			{
				addChild(tfInfo);
			}
		}

		private function dessinerFond(couleur):void
		{
			this.graphics.clear();
			//var couleurTrait= 0xCCCCCC;
			var couleurFond1,couleurFond2;
			if(couleur=="rouge")
			{
				couleurFond2= 0xD50202;
				couleurFond1= 0xFF3300;
			}
			else if(couleur=="vert")
			{
				couleurFond2= 0x6AAC28
				couleurFond1= 0x99D75B;
			}
			else if(couleur=="bleu")
			{
				couleurFond2= 0x0066CC;
				couleurFond1= 0x0099CC;
			}
						
			var gradientBoxMatrix:Matrix = new Matrix();
			gradientBoxMatrix.createGradientBox(tfInfo.width+(padding*2), tfInfo.height+(padding*2), Math.PI/2, 0, 0);
			//this.graphics.lineStyle(0.1, couleurTrait, 1);
			this.graphics.beginGradientFill(GradientType.LINEAR, [couleurFond1, couleurFond2], [1,0.95], [0,255], gradientBoxMatrix);
			this.graphics.drawRoundRect(0, 0, tfInfo.width+(padding*2), tfInfo.height+(padding*2),10);
			this.graphics.endFill();
			
		}
	}
}