﻿class Chrono {
	private var objExo;
	private var cadre_chrono:MovieClip;
	public var fond:MovieClip;
	public var curseur:MovieClip;
	private var count:Number;
	private var maxCount:Number;
	private var precision:Number;
	public var intervalId:Number;
	public var alarm:Object;
	
	
	public function Chrono(obj,precis){
		this.objExo=obj;
		if (precis == undefined) {
			this.precision = 1000;
		} else {
			this.precision = precis;
		}
		if(this.alarm == undefined){
			this.alarm=new Object();
			AsBroadcaster.initialize(alarm);
		}else{
			trace("objExo.chrono.alarm existe");
		}
		
		this.count = 0;
		this.cadre_chrono=objExo.rootMovie.createEmptyMovieClip("cadre_chrono",objExo.rootMovie.getNextHighestDepth());
		this.fond = this.cadre_chrono.attachMovie("fond_chrono", "fond", this.cadre_chrono.getNextHighestDepth());
		this.curseur=this.cadre_chrono.attachMovie("curseur_chrono", "curseur", this.cadre_chrono.getNextHighestDepth());
	}
	
	public function SetAlarm(temps_max):Void{
		this.cadre_chrono.onUnload =  function() {
			this.Stop();
		}
		maxCount=temps_max;
	}
	
	public function Start():Void {
		if (this.intervalId != null ) {
			clearInterval(this.intervalId);
		}
		intervalId = setInterval(this, "Avance", precision);
	}
	
	public function Pause():Void {
		if (this.intervalId != null) {
			clearInterval(this.intervalId);
		}
	}
	
	public function Resume():Void {
		if (this.intervalId != null) {
			clearInterval(this.intervalId);
			this.intervalId = setInterval(this, "Avance", precision);
		}
	}
	
	public function Stop():Void {
		if (this.intervalId != null) {
			clearInterval(this.intervalId);
			count = 0;
		}
	}
	
	public function GetCount(){
		return count;
	}
	
	public function Show(){
		cadre_chrono._visible=true;
	}
	public function Hide(){
		cadre_chrono._visible=false;
	}
	
	public function Destroy(){
		//this.Stop();
		clearInterval(this.intervalId);
	}
	
	private function Avance():Void {
		if(maxCount==undefined){
			clearInterval(intervalId);
			trace("Le chrono n'a pas été initialisé avec SetAlarm");
			return;
		}
		count++;
		alarm.broadcastMessage("onTic");
		if (count>=maxCount) {
			clearInterval(intervalId);
			alarm.broadcastMessage("onAlarm");
			trace("onAlarm");
			count = 0;
		}
	}
	
	
	
}