﻿package code
{
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.display.GradientType;
	import flash.geom.Matrix;
	import flash.filters.DropShadowFilter; 
	
	public class SpAlerte extends Sprite
	{
		public var msg:String;
		public var tfMessage:CalcTextField;
		public var btnValider:CalcSimpleButton;
		
		public function SpAlerte(sMsg:String)
		{
			trace("alerte created");
			msg = sMsg;
			//remplir le fond avec une couleur transparente
			graphics.beginFill(0xeeeeee,0.7);
			graphics.lineTo(735,0);
			graphics.lineTo(735,450);
			graphics.lineTo(0,450);
			graphics.endFill();
			//creer une forme rectangulaire au centre
			var rectangle:Shape = new Shape();
			rectangle.graphics.beginFill(0xffffff, 1);
			rectangle.graphics.lineStyle(1,0xcccccc);
			rectangle.graphics.drawRoundRect(0, 0, 735/3, 400/3,5);
			rectangle.x = (735-rectangle.width)/2;
			rectangle.y = (450-rectangle.height)/2 - 20
			var myFilter:DropShadowFilter = new DropShadowFilter();
			myFilter.color= 0x666666;
			myFilter.blurX = 10;
			myFilter.blurY = 10;
			rectangle.filters = new Array(myFilter);
			addChild(rectangle);
			//creer un pave texte au centre
			tfMessage = new CalcTextField();
			tfMessage.width = rectangle.width-20;
			tfMessage.wordWrap=true;
			tfMessage.autoSize = "center";
			tfMessage.x  = rectangle.x+10;
			tfMessage.y = rectangle.y +10;
			tfMessage.text = msg;
			addChild(tfMessage);
			//creer un bouton
			btnValider = new CalcSimpleButton("   OK   ");
			btnValider.x = rectangle.x + (rectangle.width - btnValider.width)/2;
			btnValider.y = rectangle.y + rectangle.height - 10 - btnValider.height;
			addChild(btnValider);
		}
		//
	}
}