﻿package code
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.events.Event;
	import flash.display.GradientType;
	import flash.geom.Matrix;
	
	public class SpQuestion extends Sprite
	{
		public var tfNumQuestion:CalcTextField;
		public var indiceQuestion:uint;
		public var texte:String;
		public var aTfMot:Array;
		public var aTfSaisie:Array;
		public var aValeur:Array;
		public var largeur:Number;
		public var hauteur:Number;
		public var padding:Number;
		private var indiceRemplacement:uint;
		
		public function SpQuestion()
		{
			this.y=340;
			this.x=20;
			largeur=280;
			hauteur=50;
			padding=10;
			//dessinerFond();
			addEventListener(Event.ADDED_TO_STAGE,afficher);
			addEventListener(Event.REMOVED_FROM_STAGE,vider);
		}
		
		public function afficher(evt:Event)
		{
			//on reinitialise tout
			var aMot=new Array();
			aTfMot = new Array();
			aTfSaisie = new Array();
			var n=0;
			//le numero de question
			tfNumQuestion= new CalcTextField();
			tfNumQuestion.multiline=false;
			tfNumQuestion.wordWrap=false;
			tfNumQuestion.textFormat.leading=0;
			tfNumQuestion.textFormat.ajouteGras();
			tfNumQuestion.textFormat.color=0xFFFFFF;
			tfNumQuestion.autoSize="center";
			tfNumQuestion.defaultTextFormat=tfNumQuestion.textFormat;
			tfNumQuestion.text=""+indiceQuestion;
			//on remplace les $val par les valeurs de aValeur
			var search:RegExp;
			if(null !== aValeur)
			{
				search=/\$val/g;
				indiceRemplacement=0;
				texte=texte.replace(search,remplacerVal);
			}
			
			
			aMot=texte.split(" ");
			for (var mot:String in aMot)
			{
				var tfMot = new CalcTextField();
				tfMot.multiline=false;
				tfMot.wordWrap=false;
				tfMot.textFormat.leading=0;
				tfMot.defaultTextFormat=tfMot.textFormat;
				if(aMot[mot]!=="$var")
				{
					tfMot.text=aMot[mot];
					tfMot.selectable = false;
				}
				else {
					tfMot.type="input";
					tfMot.autoSize="none";
					tfMot.textFormat.align="center";
					tfMot.defaultTextFormat=tfMot.textFormat;
					tfMot.width=50;
					tfMot.height=tfMot.textFormat.size+6;
					tfMot.border=true;
					tfMot.background=true;
					tfMot.borderColor=0xCCCCCC;
					tfMot.backgroundColor=0xFFFFFF;
					aTfSaisie.push(tfMot);
				}
				aTfMot.push(tfMot);
			}
			disposerMot();
			dessinerFond();
			
			function remplacerVal():String
			{
				var remp = aValeur[indiceRemplacement];
				indiceRemplacement++;
				return remp
			}
		}
		
		private function disposerMot():void
		{
			for (var i=0;i<aTfMot.length;i++)
			{
				if(i == 0)
				{
					aTfMot[i].x=padding;
					aTfMot[i].y=20+padding;
				}
				else
				{
					var currentX:Number=aTfMot[i-1].x+aTfMot[i-1].width;
					var currentY:Number=aTfMot[i-1].y;
					if(largeur-currentX > aTfMot[i].width)
					{
						if(aTfMot[i].type=="input")
						{
							aTfMot[i].x=aTfMot[i-1].x+aTfMot[i-1].width+5;
							aTfMot[i].y=currentY;
						}
						else {
							if(aTfMot[i-1].type=="input")
							{
								aTfMot[i].x=aTfMot[i-1].x+aTfMot[i-1].width+5;
								aTfMot[i].y=currentY;
							}
							else
							{
								aTfMot[i].x=aTfMot[i-1].x+aTfMot[i-1].width;
								aTfMot[i].y=currentY;
							}
						}
					}
					else
					{
						aTfMot[i].x=aTfMot[0].x;
						aTfMot[i].y=currentY+aTfMot[i].height+2;
					}
					hauteur=aTfMot[i].y+aTfMot[i].height-aTfMot[0].y;
				}
				addChild(aTfMot[i]);
			}
			if(aTfSaisie.length>0)
			{
				stage.focus=aTfSaisie[0];
			}
			tfNumQuestion.x=10+((40-tfNumQuestion.width)/2);
			tfNumQuestion.y=-2;
			addChild(tfNumQuestion);
		}
		
		private function dessinerFond():void
		{
			
			this.graphics.clear();
			var couleurTrait=0x0099CC;
			var couleurFond=0x0099CC;
			//var gradientBoxMatrix:Matrix = new Matrix();
			//gradientBoxMatrix.createGradientBox(15,15, Math.PI/2, 0, 0);
			this.graphics.lineStyle(3, couleurTrait, 1);
			//this.graphics.beginGradientFill(GradientType.LINEAR, [0xFFFFFF, couleurFond], [1,0.5], [0,255], gradientBoxMatrix);
			this.graphics.beginFill(couleurFond);
			this.graphics.drawCircle(30, 20, 20);
			//
			couleurTrait=0x0099CC;
			couleurFond=0xFFFFFF;
			var gradientBoxMatrix:Matrix = new Matrix();
			gradientBoxMatrix.createGradientBox(largeur, hauteur+(padding*2), Math.PI/2, 0, 0);
			this.graphics.lineStyle(3, couleurTrait, 1);
			this.graphics.beginGradientFill(GradientType.LINEAR, [0xFFFFFF, couleurFond], [1,1], [0,255], gradientBoxMatrix);
			this.graphics.drawRoundRect(0, 20, this.largeur+(padding), this.hauteur+(padding*2),10);
			
		}
		
		public function vider(evt:Event):void
		{
			var i,j:uint;
			stage.focus=null;
			/*
			for (i=0;i<aTfMot.length;i++)
			{
				removeChild(aTfMot[i]);
				aTfMot[i]=null;
			}
			removeChild(tfNumQuestion);
			tfNumQuestion=null;
			*/
			while(this.numChildren>0)
			{
				removeChild(this.getChildAt(0));
			}
		}
	}
	
}