﻿package code
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.display.GradientType;
	import flash.geom.Matrix;
	
	public class SpResultat extends Sprite
	{
		public var tfTitre:CalcTextField;
		public var tfScore:CalcTextField;
		public var tfScorePremierEssai:CalcTextField;
		public var tfTemps:CalcTextField;
		
		public function SpResultat()
		{
			tfTitre = new CalcTextField;
			tfTitre.multiline=false;
			tfTitre.wordWrap=false;
			//tfTitre.border=true;
			tfTitre.autoSize= TextFieldAutoSize.LEFT;
			tfTitre.textFormat.align="left";
			
			tfTitre.textFormat.ajouteGras();
			tfTitre.textFormat.size=18;
			tfTitre.defaultTextFormat=tfTitre.textFormat;
			tfTitre.text="Voici tes résultats";
			tfTitre.y=20;
			//tfTitre.x=(735-tfTitre.width)/2;
			addChild(tfTitre);
			//
			tfScore = new CalcTextField;
			tfScore.multiline=false;
			tfScore.wordWrap=false;
			tfScore.autoSize= TextFieldAutoSize.LEFT;
			tfScore.textFormat.align="left";
			tfScore.textFormat.size=16;
			
			tfScore.defaultTextFormat=tfScore.textFormat;
			//
			tfScorePremierEssai = new CalcTextField;
			tfScorePremierEssai.multiline=false;
			tfScorePremierEssai.wordWrap=false;
			tfScorePremierEssai.autoSize= TextFieldAutoSize.LEFT;
			tfScorePremierEssai.textFormat.align="left";
			tfScorePremierEssai.textFormat.size=16;
			tfScorePremierEssai.textFormat.color=0xFFFFFF;
			tfScorePremierEssai.defaultTextFormat=tfScore.textFormat;
			//
			tfTemps = new CalcTextField;
			tfTemps.multiline=false;
			tfTemps.wordWrap=false;
			tfTemps.autoSize= TextFieldAutoSize.LEFT;
			tfTemps.textFormat.align="left";
			tfTemps.textFormat.size=16;
			tfTemps.textFormat.color=0xFFFFFF;
			tfTemps.defaultTextFormat=tfScore.textFormat;
		}
		
		public function ajouterScore(score:uint,scorePremierEssai:uint,totalReponse:uint,temps:String,essaiMultiple:Boolean)
		{
			tfScore.text="Score : "+score+" sur "+totalReponse;
			tfScore.y=tfTitre.y+tfTitre.height+20;
			tfScore.x=20;
			addChild(tfScore);
			//
			if(essaiMultiple)
			{
			tfScorePremierEssai.text="Nombre de reussites au premier essai : "+scorePremierEssai;
			}
			else
			{
				tfScorePremierEssai.text="";
			}
			tfScorePremierEssai.y=tfScore.y+tfScore.height+20;
			tfScorePremierEssai.x=20;
			addChild(tfScorePremierEssai);
			
			//
			tfTemps.text="Exercice réalisé en : "+temps;
			tfTemps.y=tfScorePremierEssai.y+tfScorePremierEssai.height+20;
			tfTemps.x=20;
			addChild(tfTemps);
			dessinerFond()
			this.x = (735 - this.width)/2;
			this.y = 100;
			tfTitre.x = (this.width - tfTitre.width)/2;
			//
			
		}
		
		private function dessinerFond():void
		{
			this.graphics.clear();
			var couleurTrait= 0xCCCCCC;
			var couleurFond1,couleurFond2;
			var padding=20;
			couleurFond2= 0xEEEEEE;
			couleurFond1= 0xFFFFFF;
			
						
			var gradientBoxMatrix:Matrix = new Matrix();
			gradientBoxMatrix.createGradientBox(this.width+2*padding, this.height+2*padding, Math.PI/2, 0, 0);
			this.graphics.lineStyle(0.1, couleurTrait, 1);
			this.graphics.beginGradientFill(GradientType.LINEAR, [couleurFond1, couleurFond2], [0.85,1], [0,255], gradientBoxMatrix);
			this.graphics.drawRoundRect(0, 0, this.width+2*padding, this.height+2*padding,10);
			
		}
	}
}