﻿class CalcExo {
	public  var rootMovie:MovieClip;
	public  var zone_titre:CadreTitre;
	public  var zone_question:CadreQuestion;
	public  var zone_info:CadreInfo;
	public  var zone_score:CadreScore;
	public  var zone_animation:MovieClip;
	public  var zone_options:CadreOptions;
	public  var zone_resultat:CadreResultat;
	//
	public  var btn_commencer:Bouton;
	public  var btn_options:Bouton;
	public  var btn_valider:Bouton;
	public  var btn_suite:Bouton;
	public  var btn_valider_options:Bouton;
	public  var btn_tester_options:Bouton;
	//
	public  var occupe:Boolean;
	public  var options:Object;
	public  var contexte:String;
	public  var save_score:String;
	public  var uid:Number;
	public  var seanceid:Number;
	public  var statut_utilisateur:String;
	public  var optionsFromAir:String;
	public  var NomMethodeJS1:String;
	public  var NomMethodeJS2:String;
	public  var ClipMep:MovieClip;
	
	//
	private  var nom:String;
	private  var langue:String;
	private  var rep_langue:String;
	private  var url_langue:String;
	private  var textes_communs:Array;
	private  var textes_exo:Array;
	private  var fichier_langue_commun:String;
	private  var fichier_langue_exo:String;
	private  var temps:Number;
	private  var textes_charges:Boolean=false;
	private  var options_chargees:Boolean=false;
	private  var controles_option:Array = new Array();
	private  var default_options:Boolean;
	private  var chrono:Chrono;
	public  var chrono_question:Chrono;
	private  var difSuite:Object;
	private  var listSuite:Object;
	private  var valider_empty:Boolean;
	private  var keyListener:Object;
	private var masque:MovieClip;
	
	//
	//Fonctions publiques
	public  function CalcExo(mc) {
		var exo=this;
		this.rootMovie=mc;
		this.chrono_question=undefined;
		this.rootMovie.onUnload=function (){
			
			if(exo.chrono!=undefined){
				exo.chrono.Stop()
			}
			if(exo.chrono_question!=undefined){
				exo.chrono_question.Stop()
			}
			Key.removeListener(this.keyListener);
			for (var prop in exo){
				prop=undefined;
			}
			
		}
		
		ClipMep=this.rootMovie.createEmptyMovieClip("ClipMep",this.rootMovie.getNextHighestDepth());
	
		//gestion de l'appui sur la touche Enter
		if(this.keyListener==undefined){
			this.keyListener=new Object();
		}
		this.keyListener.onKeyDown = function() {
			if (Key.getCode() == 13) {
				if (exo.btn_valider.bouton._visible == true ) {
					if(!exo.valider_empty){
						//pour éviter le blocage du chrono par clic répété sur valider quand la zone de saisie est vide
						exo.chrono_question.Pause();
					}
					exo.btn_valider.bouton._visible = false;
					exo.zone_score.numessai++;
					var res_eval = exo.rootMovie.evaluer();
					exo.Avancer(res_eval);
				}else if(exo.btn_suite.bouton._visible == true ) {
					exo.btn_suite.Hide();
					exo.SuiteAuto();
				}
			}
		};
		Key.removeListener(this.keyListener);
		Key.addListener(this.keyListener);
		//
		this.nom =rootMovie.nom_exo;
		// les variables que l'on peut passer dans l'url du swf : 
		// id_this, langue, url_langue, contexte, statut 
		this.uid = this.rootMovie.id_exo;
		this.seanceid=this.rootMovie.id_seance;
		this.rootMovie.langue==undefined ? this.langue = "fr" : this.langue = this.rootMovie.langue;
		this.url_langue = this.rootMovie.rep_langue;
		this.contexte=this.rootMovie.contexte;
		this.save_score=this.rootMovie.save_score;
		this.statut_utilisateur=this.rootMovie.statut;
		this.rep_langue=this.GetRepertoireLang();
		this.fichier_langue_commun = this.rep_langue+"calculatice_commun.txt";
		//this.fichier_langue_commun = "flash/lang/fr/calculatice_commun.txt";
		this.fichier_langue_exo = this.rep_langue+this.nom+".txt";
		//this.fichier_langue_this = "flash/lang/fr/"+this.nom+".txt";
		this.occupe = false;
		//On charge les textes depuis les fichiers de langue
		//asynchrone
		this.textes_charges=false;
		this.LoadTextes();
		var exo=this;
		//On attend que les textes et les options soient chargés pour passer à la frame suivante
		this.rootMovie.onEnterFrame = function() {
			//if (this.textes_charges == true && this.options_chargees == true) {
			if (exo.textes_charges == true) {
				delete exo.rootMovie.onEnterFrame;
				//On cree le masque
				exo.CreeMasque();
				//On charge le fond
				exo.CreeFond();
				//
				Signe.Init();
				//On cree la zone qui affichera le titre de l'exercice et la consigne de depart
				exo.CreeZoneTitre();
				//On crée la zone qui affichera le numéro de question et les énooncés de questions
				exo.CreeZoneQuestion();
				// On crée la zone qui accueillera le score
				exo.CreeZoneScore();
				// On crée la zone qui accueillera les resultats
				exo.CreeZoneResultat();
				// On crée la zone des options
				exo.CreeZoneOptions();
				// On crée la zone qui accueillera les feedbacks
				exo.CreeZoneInfo();
				//On cree les boutons "Valider" "Suite" et "Commencer"
				exo.CreeBoutons();
				//on charge les options depuis la base de donnees 
				//ou les options par defaut
				//on passe au frame suivant
				exo.LoadOptions(exo.contexte, exo.rootMovie.options_par_defaut);
			}
		};
		
		
	}
	
	//
	public  function InitFrame2() {
		var exo=this;
		//Permet à l'utilisateur LaboMEP de declencher la methode EnregistrerOptions
		//quand il clique sur le bouton enregistrer dans l'interface LaboMEP
		NomMethodeJS1= "sendSignalToFlash";
		var instance1:Object = null;
		var NomMethodeAS1:Function = EnregistrerOptionsPourMep;
		var ret1:Boolean = flash.external.ExternalInterface.addCallback(NomMethodeJS1, instance1, NomMethodeAS1);
		//Permet à l'utilisateur LaboMEP d'arrêter l'this
		//quand il clique sur le bouton Arreter exercice dans l'interface LaboMEP
		NomMethodeJS2= "rewind";
		var instance2:Object = null;
		var NomMethodeAS2:Function = rewind;
		var ret2:Boolean = flash.external.ExternalInterface.addCallback(NomMethodeJS2, instance2, NomMethodeAS2);
		//On charge les fonctions reseau pour mep
		if(this.contexte=="LaboMEP"){
			var mcLoader:MovieClipLoader = new MovieClipLoader();
			mcLoader.loadClip("fonctions_reseau.swf", this.ClipMep);

		}
		// On cree un chrono
		if (this.options.temps_max>0){
		//C'est un chrono pour l'ensemble de l'this
			if (this.chrono == undefined) {
				this.CreerChronoExercice();
				this.chrono.Hide();
			} else {
				this.chrono.Stop();
				this.chrono.fond._width = 735;
				this.chrono.curseur._width=735;
				this.chrono.SetAlarm(this.options.temps_max);
				this.chrono.Hide();
			}
		}else if (this.options.temps_question>0){
		//C'est un chrono pour chaque question
			if (this.chrono_question == undefined) {
				this.CreerChronoQuestion();
				this.chrono_question.Hide();
			} else {
				this.chrono_question.Stop();
				this.chrono_question.fond._width = 735;
				this.chrono_question.curseur._width=735;
				this.chrono_question.SetAlarm(this.options.temps_question);
				this.chrono_question.Hide();
			}
		}
		
		this.btn_commencer.Show();
		this.btn_commencer.bouton.onRelease = function() {
			exo.zone_titre.Hide();
			exo.btn_commencer.Hide();
			exo.btn_options.Hide();
			exo.temps=getTimer();
			exo.rootMovie.gotoAndPlay(3);
		};
		if (this.contexte==undefined 
			|| (this.contexte=="appli-calculatice" && this.statut_utilisateur=="prof") 
			|| this.contexte=="Air" 
			|| (this.contexte=="LaboMEP" && this.statut_utilisateur=="prof") 
			|| (this.contexte=="calculatice-flex" && this.statut_utilisateur=="prof") 
			) {
			this.btn_options.Show();
		}
		this.btn_options.bouton.onRelease = function() {
			exo.occupe=false;
			exo.rootMovie.gotoAndStop(5);
			exo.zone_titre.Hide();
			exo.btn_commencer.Hide();
			exo.btn_options.Hide();
		};
		this.zone_question.numquestion = 0;
		this.zone_score.score = 0;
		this.zone_score.score_premier_essai = 0;
		
		
	}
	//
	public  function InitFrame3() {
		var exo=this;
		//Creation de l'animation
		this.InitAnimation();
		//On démarre le chrono
		if (this.options.temps_max>0) {
			this.chrono.fond._width = this.chrono_question.curseur._width=735;
			this.chrono.SetAlarm(this.options.temps_max);
			this.chrono.Start();
			this.chrono.Show();
		}else if (this.options.temps_question>0) {
			this.chrono_question.fond._width = this.chrono_question.curseur._width=735;
			this.chrono_question.SetAlarm(this.options.temps_question);
			this.chrono_question.Start();
			this.chrono_question.Show();
		}
		//           
		this.zone_question.numquestion++;
		this.zone_score.numessai = 0;
		this.zone_question.Show();
		zone_question.SetFocus();
		//
		//on cache le bouton "Suite"
		this.btn_suite.Hide();
		//on affiche le bouton valider
		this.btn_valider.Show();
		//Gestion du clic sur "Valider"
		this.valider_empty=false;
		this.btn_valider.bouton.onRelease = function() {
			//!!!! éviter la mise ne pause du chrono par clic répété sur valider quand la zone de saisie est vide
			if(!exo.valider_empty){
				exo.chrono_question.Pause();
			}
			exo.btn_valider.Hide();
			exo.zone_score.numessai++;
			var res_eval = exo.rootMovie.evaluer();
			exo.Avancer(res_eval);
		};
		//
	}
	//
	public  function InitFrame5() {
		var exo=this;
		zone_question.SetFocus();
		this.btn_valider_options.bouton.onRelease = function() {
			for (var i = 0; i<exo.zone_options.controles_option.length; i++) {
				var controle = exo.zone_options.controles_option[i];
				exo.options[controle.nom] = controle.GetValeur();
			}
			//import flash.external.*;
			exo.EnregistrerOptions(exo.contexte);
		};
		this.zone_options.Show();
		
		if(this.contexte=="LaboMEP"){
			this.btn_valider_options.Hide();
			this.btn_tester_options.Show();
		}else{
			this.btn_valider_options.Show();
		}
		this.btn_tester_options.bouton.onRelease = function() {
			if(exo.contexte=="LaboMEP"){
				for (var i = 0; i<exo.zone_options.controles_option.length; i++) {
					var controle = exo.zone_options.controles_option[i];
					exo.options[controle.nom] = controle.GetValeur();
				}
			}
			exo.zone_options.Hide();
			exo.btn_valider_options.Hide();
			exo.btn_tester_options.Hide();
			exo.rootMovie.gotoAndStop(2);
		};
	}
	//
	public  function GetTrad(indice:String) {
		return this.textes_exo[indice];
	}
	public  function GetTradCommun(indice:String) {
		return this.textes_communs[indice];
	}
	public  function GetNumQuestion() {
		return this.zone_question.numquestion;
	}
	//Permet de valider une réponse sans clic sur le bouton Valider (simule le clic sur le bouton Valider)
	public  function ValiderAuto(){
		this.chrono_question.Stop();
		this.zone_score.numessai++;
		var res_eval = this.rootMovie.evaluer();
		this.Avancer(res_eval);
		this.btn_valider.Hide();
		return res_eval
	}
	
	//Permet de passer à la question suivante sans clic sur le bouton Suite (simule le clic sur le bouton Suite)
	public  function SuiteAuto(objExo){
		trace("SuiteAuto()");
		if(objExo==undefined)
			objExo=this;
		objExo.btn_suite.Hide();
		if(objExo.chrono.curseur._width==0 && objExo.options.temps_max>0){
			//le temps de l'exo est depasse
			objExo.occupe = false;
			objExo.btn_suite.Hide();
			objExo.zone_info.Hide();
			objExo.zone_question.Hide();
			objExo.zone_score.Hide();
			if (objExo.chrono != undefined) {
				objExo.chrono.Hide();
			}
			objExo.zone_animation.removeMovieClip();
			//afficher les resultats
			objExo.AfficherResultat(objExo.zone_score.score, objExo.zone_score.score_premier_essai);
			objExo.zone_resultat.Show();
			objExo.EnregistrerResultat(objExo.contexte);
			return;
		} else if(objExo.chrono_question.curseur._width==0 && objExo.options.temps_question>0){
			//le temps de la question est depasse
			if(objExo.zone_question.numquestion<objExo.options.nbre_questions){
				objExo.occupe = false;
				objExo.rootMovie.gotoAndPlay(3);
				objExo.zone_info.Hide();
			} else{
				objExo.occupe = false;
				objExo.btn_suite.Hide();
				objExo.zone_info.Hide();
				objExo.zone_question.Hide();
				objExo.zone_score.Hide();
				if (objExo.chrono_question != undefined) {
					objExo.chrono_question.Hide();
				}
				objExo.zone_animation.removeMovieClip();
				//afficher les resultats
				objExo.AfficherResultat(this.zone_score.score, this.zone_score.score_premier_essai);
				objExo.zone_resultat.Show();
				objExo.EnregistrerResultat(this.contexte);
			}
			return;
		}
		var resultat_evaluation = objExo.rootMovie.evaluer();
		//si temps depasse on enregistre le resultat
		if (resultat_evaluation == "juste") {
			if (objExo.zone_question.numquestion<objExo.options.nbre_questions) {
				//Ce n'est pas la dernière question
				objExo.occupe = false;
				objExo.zone_info.Hide();
				objExo.rootMovie.gotoAndPlay(3);				
			} else {
				//C'est la dernière question
				objExo.btn_suite.Show();
			}
		} else if (resultat_evaluation == "faux") {
			if (objExo.zone_question.numquestion<objExo.options.nbre_questions) {
			//Ce n'est pas la dernière question
				if(objExo.zone_score.numessai==objExo.options.max_essais){
				//Ce n'est pas la dernière question dernier essai
					objExo.occupe = false;
					objExo.zone_info.Hide();
					objExo.rootMovie.gotoAndPlay(3);
				}
			} else {
			//C'est la dernière question 
				if(objExo.zone_score.numessai>=objExo.options.max_essais){
					//C'est la dernière question dernier essai
					objExo.occupe = false;
					objExo.btn_suite.Hide();
					objExo.zone_info.Hide();
					objExo.zone_question.Hide();
					objExo.zone_score.Hide();
					if (objExo.chrono != undefined) {
						objExo.chrono.Hide();
					}
					objExo.zone_animation.removeMovieClip();
					//afficher les resultats
					objExo.AfficherResultat(this.zone_score.score, this.zone_score.score_premier_essai);
					objExo.zone_resultat.Show();
					objExo.EnregistrerResultat(this.contexte);
				}
				
			}
		}
	}
	
	
	// ***********************************************
	//			Fonctions internes					*
	// ***********************************************
	//cree un fond rayé bleu style mep
	private  function CreeFond() {
		//var fond = this.rootMovie.createEmptyMovieClip("fond", -20000);
		var fond=this.rootMovie;
		var hauteur_totale = 450;
		var largeur_totale = 735;
		for (var i = 0; i<=hauteur_totale/4; i++) {
			var j = 4*i;
			with (fond) {
				lineStyle(1, "0xFFFFFF", 100);
				moveTo(0, j);
				lineTo(largeur_totale, j);
				lineStyle(1, "0xF6F6F5", 100);
				moveTo(0, j+1);
				lineTo(largeur_totale, j+1);
				lineStyle(1, "0xF0F0F0", 100);
				moveTo(0, j+2);
				lineTo(largeur_totale, j+2);
				lineStyle(1, "0xF4F4F3", 100);
				moveTo(0, j+3);
				lineTo(largeur_totale, j+3);
			}
		}
		
	}
	//
	private function CreeMasque():Void{
		var masque=this.rootMovie.attachMovie("Mask","masque",this.rootMovie.getNextHighestDepth());
		/*var masque=this.rootMovie.createEmptyMovieClip("masque",this.rootMovie.getNextHighestDepth());
		masque.beginFill("0xffffff",100);
		masque.moveTo(0,0);
		masque.moveTo(0,735);
		masque.moveTo(450,735);
		masque.moveTo(450,0);
		masque.moveTo(0,0);
		masque.endFill();*/
		this.rootMovie.setMask(masque);
	}
		
	private  function GetRepertoireLang(){
		if(this.url_langue==undefined){
			var url_movie=this.rootMovie._url
			var index=url_movie.indexOf("?");
			if(index>-1){
				url_movie=url_movie.substring(0,index);
			}
			var repertoire_lang=url_movie.substring(0,url_movie.lastIndexOf("/"))+"/lang/"+this.langue+"/";
		}else{
			var repertoire_lang=this.url_langue+"/";
		}
		return repertoire_lang;
	};
	//retourne un tableau indexé de consignes et indications au format string
	//@param chaine : le contenu d'un fichier lang
	private function LoadTextes() {
		var exo=this;
		var lv = new LoadVars();
		lv.onData = function(src) {
			if(src!=undefined){
				lv.unload();
				exo.textes_communs = exo.MettreEnTableau(src);
				var lv2 = new LoadVars();
				lv2.onData = function(src2) {
					if(src2!=undefined){
						exo.textes_exo = exo.MettreEnTableau(src2);
						lv2.unload();
						exo.textes_charges = true;
					}else{
						delete exo.rootMovie.onEnterFrame;
					}
				};
				lv2.load(exo.fichier_langue_exo);
			}else{
				delete exo.rootMovie.onEnterFrame;
			}
		};
		lv.load(this.fichier_langue_commun);
	}
	
	private  function SetDefaultOptions(options:Object) {
		this.options = options;
		this.default_options == true;
	}
	public  function GetTexteDynamique(texte, aNombres) {
		var texte_traduit = "";
		var indice_nombre = 0;
		var arrayMots = texte.split(" ");
		for (var i = 0; i<arrayMots.length; i++) {
			if (arrayMots[i] != "$clip$") {
				if (arrayMots[i] != "$var$") {
					texte_traduit += arrayMots[i]+" ";
				} else if (arrayMots[i] == "$var$") {
					texte_traduit += aNombres[indice_nombre]+" ";
					indice_nombre++;
				}
			}
		}
		return texte_traduit;
	}
	//
	private  function CreeBoutons() {
		//On cree les boutons
		this.btn_commencer = new Bouton(this.rootMovie, "btn_commencer", this.textes_communs["p1_1"]);
		this.btn_commencer.SetPos((735-btn_commencer.bouton._width)/2, 400);
		this.btn_valider = new Bouton(this.rootMovie, "btn_valider", this.textes_communs["p1_2"]);
		this.btn_valider.SetPos(600, 415);
		this.btn_suite = new Bouton(this.rootMovie, "btn_suite", this.textes_communs["p1_3"]);
		this.btn_suite.SetPos(600, 415);
		this.btn_options = new Bouton(this.rootMovie, "btn_options", "Options");
		this.btn_options.SetPos(735-btn_options.bouton._width-10, 10);
		this.btn_valider_options = new Bouton(this.rootMovie, "btn_valider_options", "Valider");
		this.btn_valider_options.SetPos((735-this.btn_valider_options.bouton._width)/2, this.rootMovie._height-this.btn_valider_options.bouton._height-10);
		this.btn_tester_options = new Bouton(this.rootMovie, "btn_tester_options", "Tester");
		this.btn_tester_options.SetPos(this.btn_valider_options.bouton._x+this.btn_valider_options.bouton._width+10, this.btn_valider_options.bouton._y);
		//On les cache
		this.btn_commencer.Hide();
		this.btn_valider.Hide();
		this.btn_suite.Hide();
		this.btn_options.Hide();
		this.btn_valider_options.Hide();
		this.btn_tester_options.Hide();
		//
		
	}
	//
	private  function CreeZoneTitre() {
		this.zone_titre = new CadreTitre(this);
	}
	private  function CreeZoneQuestion() {
		this.zone_question = new CadreQuestion(this);
	}
	private  function CreeZoneInfo() {
		this.zone_info = new CadreInfo(this);
	}
	private  function CreeZoneScore() {
		this.zone_score = new CadreScore(this);
	}
	private  function CreeZoneResultat() {
		this.zone_resultat = new CadreResultat(this);
	}
	private  function CreerChronoExercice() {
		var exo=this;
		if(chrono==undefined){
			exo.chrono = new Chrono(exo);
		}else{
			return;
		}
		chrono.SetAlarm(options.temps_max);
		chrono.alarm.removeListener(myListener1);
		chrono.alarm.removeListener(myListener2);
		chrono.fond._width = this.chrono.curseur._width=735;
		chrono.fond._height = this.chrono.curseur._height=10;
		//on ajoute la barre de défilement du temps
		var myListener1:Object = new Object();
		var myListener2:Object = new Object();
		// Creates listener object.
		myListener1.onAlarm = function() {
			// Creates listener method.
			exo.Avancer("temps_depasse");
			trace("myListener1 temps depasse");
			occupe=true;
			chrono.curseur._width = 0;
		};
		myListener2.onTic = function() {
			// Creates listener method.
			exo.chrono.curseur._width -= exo.chrono.fond._width/exo.options.temps_max;
		};
		chrono.alarm.addListener(myListener1);
		chrono.alarm.addListener(myListener2);
	}
	private  function CreerChronoQuestion() {
		var exo=this;
		if(chrono==undefined){
			chrono_question = new Chrono(this);
		}else{
			return;
		}
		chrono_question.SetAlarm(this.options.temps_question);
		chrono_question.alarm.removeListener(myListener1);
		chrono_question.alarm.removeListener(myListener2);
		chrono_question.fond._width = this.chrono_question.curseur._width=735;
		chrono_question.fond._height = this.chrono_question.curseur._height=10;
		//on ajoute la barre de défilement du temps
		var myListener1:Object = new Object();
		var myListener2:Object = new Object();
		// Creates listener object.
		myListener1.onAlarm = function() {
			// Creates listener method.
			exo.Avancer("temps_question_depasse");
			exo.occupe=true;
			exo.chrono_question.curseur._width = 0;
		};
		myListener2.onTic = function() {
			// Creates listener method.
			exo.chrono_question.curseur._width -= exo.chrono_question.fond._width/exo.options.temps_question;
		};
		chrono_question.alarm.addListener(myListener1);
		chrono_question.alarm.addListener(myListener2);
	}
	
	private  function InitAnimation() {
		if (this.zone_animation != undefined) {
			this.zone_animation.removeMovieClip();
		}
		this.zone_animation = this.rootMovie.createEmptyMovieClip("zone_animation", this.rootMovie.getNextHighestDepth());
	}
	private  function CreeZoneOptions() {
		this.zone_options = new CadreOptions(this);
		this.zone_options.Hide();
	}
	//Comme Avancer() mais pour un exercice ou on ne clique pas sur valider
	public  function Poursuivre(resultat_evaluation, numquestion, suite) {
		var exo=this
		if (resultat_evaluation == "juste" && suite == true) {
			//reponse juste exercice pas terminé
			this.zone_score.SetScore(1, numquestion);
		} else if (resultat_evaluation == "juste" && suite == false) {
			//reponse juste exercice terminé
			this.zone_score.SetScore(1, numquestion);
			this.temps=getTimer()-this.temps;
			if (this.chrono != undefined) {
				this.chrono.Stop();
			}
			this.zone_info.SetInfo(this.zone_info.msg_jdq);
			this.zone_info.Show();
			this.btn_suite.Show();
			this.btn_suite.bouton.onRelease = function() {
				exo.occupe = false;
				exo.btn_suite.Hide();
				exo.zone_info.Hide();
				exo.zone_question.Hide();
				exo.zone_score.Hide();
				if (exo.chrono != undefined) {
					exo.chrono.Hide();
				}
				exo.zone_animation.swapDepths(1048575);
				exo.zone_animation.removeMovieClip();
				//afficher les resultats
				exo.AfficherResultat(exo.zone_score.score, exo.zone_score.score_premier_essai);
				exo.zone_resultat.Show();
				exo.EnregistrerResultat(exo.contexte);
			};
		} else if (resultat_evaluation == "faux" && suite == true) {
			//reponse fausse exercice pas terminé
			this.zone_score.SetScore(0, numquestion);
		} else if (resultat_evaluation == "faux" && suite == false) {
			//reponse fausse exercice terminé
			this.zone_score.SetScore(0, numquestion);
			this.temps=getTimer()-this.temps;
			if (this.chrono != undefined) {
				this.chrono.Stop();
			}
			this.zone_info.SetInfo(this.zone_info.msg_fdq);
			//this.zone_score.SetScore(0, this.zone_question.numquestion);
			this.zone_info.Show();
			this.btn_suite.Show();
			this.btn_suite.bouton.onRelease = function() {
				exo.occupe = false;
				exo.btn_suite.Hide();
				exo.zone_info.Hide();
				exo.zone_question.Hide();
				exo.zone_score.Hide();
				if (exo.chrono != undefined) {
					exo.chrono.Hide();
				}
				exo.zone_animation.removeMovieClip();
				//afficher les resultats
				exo.AfficherResultat(exo.zone_score.score, exo.zone_score.score_premier_essai);
				exo.zone_resultat.Show();
				exo.EnregistrerResultat(exo.contexte);
			};
		}
	}
	private  function Avancer(resultat_evaluation) {
		var exo=this;
		//on bloque la zone de saisie si elle existe 
		this.occupe = true;
		//
		this.zone_question.Desactive();
		//si temps depasse on enregistre le resultat
		if (resultat_evaluation == "temps_depasse") {
			trace("avancer temps_depasse");
			this.chrono.Stop();
			this.temps=getTimer()-this.temps;
			this.btn_valider.Hide();
			this.zone_info.SetInfo(this.textes_communs["p3_7"]);
			this.zone_info.Show();
			this.btn_suite.Show();
			this.btn_suite.bouton.onRelease = function() {
				exo.occupe = false;
				exo.btn_suite.Hide();
				exo.zone_info.Hide();
				exo.zone_question.Hide();
				exo.zone_score.Hide();
				if (exo.chrono != undefined) {
					exo.chrono.Hide();
				}
				exo.zone_animation.removeMovieClip();
				//afficher les resultats
				exo.AfficherResultat(exo.zone_score.score, exo.zone_score.score_premier_essai);
				exo.zone_resultat.Show();
				exo.EnregistrerResultat(exo.contexte);
			};
		} else if(resultat_evaluation=="temps_question_depasse"){
			this.chrono_question.Stop();
			this.temps=getTimer()-this.temps;
			this.btn_valider.Hide();
			this.zone_info.SetInfo(this.textes_communs["p3_7"]);
			this.zone_score.SetScore(0, this.zone_question.numquestion);
			this.zone_info.Show();
			this.btn_suite.Show();
			this.btn_suite.bouton.onRelease = function() {
				if(exo.zone_question.numquestion<exo.options.nbre_questions){
					exo.occupe = false;
					exo.rootMovie.gotoAndPlay(3);
					exo.zone_info.Hide();
				} else{
					exo.occupe = false;
					exo.btn_suite.Hide();
					exo.zone_info.Hide();
					exo.zone_question.Hide();
					exo.zone_score.Hide();
					if (exo.chrono_question != undefined) {
						exo.chrono_question.Hide();
					}
					exo.zone_animation.removeMovieClip();
					//afficher les resultats
					exo.AfficherResultat(exo.zone_score.score, exo.zone_score.score_premier_essai);
					exo.zone_resultat.Show();
					exo.EnregistrerResultat(this.contexte);
				}
			};
		} else if (resultat_evaluation == "rien") {
			//on rend la main à l'utilisateur;
			if(!this.valider_empty){
				this.chrono_question.Resume();
				this.valider_empty=true;
			}
			this.zone_question.Active();
			this.zone_info.SetInfo(this.zone_info.msg_norep);
			this.zone_info.Show();
			this.zone_score.numessai = 0;
			this.btn_valider.Show();
			this.occupe = false;
		} else if (resultat_evaluation == "juste") {
			this.chrono_question.Stop();
			this.chrono_question.Hide();
			this.zone_score.SetScore(1, this.zone_question.numquestion);
			if (this.zone_question.numquestion<this.options.nbre_questions) {
				//Ce n'est pas la dernière question
				this.zone_info.SetInfo(this.zone_info.msg_j);
				this.zone_info.Show();
				this.btn_valider.Hide();
				this.btn_suite.bouton.onRelease = function() {
					exo.occupe = false;
					exo.rootMovie.gotoAndPlay(3);
					exo.zone_info.Hide();
				};
				this.btn_suite.Show();
			} else {
				//C'est la dernière question
				this.temps=getTimer()-this.temps;
				if (this.chrono != undefined) {
					this.chrono.Stop();
				}
				this.zone_info.SetInfo(this.zone_info.msg_jdq);
				this.zone_info.Show();
				this.btn_suite.Show();
				this.btn_suite.bouton.onRelease = function() {
					exo.occupe = false;
					exo.btn_suite.Hide();
					exo.zone_info.Hide();
					exo.zone_question.Hide();
					exo.zone_score.Hide();
					if (exo.chrono != undefined) {
						exo.chrono.Hide();
					}
					exo.zone_animation.swapDepths(1048575);
					exo.zone_animation.removeMovieClip();
					//afficher les resultats
					exo.AfficherResultat(exo.zone_score.score, exo.zone_score.score_premier_essai);
					exo.zone_resultat.Show();
					exo.EnregistrerResultat(exo.contexte);
				};
			}
		} else if (resultat_evaluation == "faux") {
			if (this.zone_question.numquestion<this.options.nbre_questions) {
				//Ce n'est pas la dernière question
				if (this.zone_score.numessai<this.options.max_essais) {
					//Ce n'est pas la dernière question premier essai
					
					if(!this.valider_empty){
						this.chrono_question.Resume();
					}
					this.zone_info.SetInfo(this.zone_info.msg_fpe);
					this.zone_info.Show();
					this.btn_valider.Show();
					this.occupe = false;
					this.zone_question.Active();
				} else {
					this.chrono_question.Stop();
					this.chrono_question.Hide();
					//Ce n'est pas la dernière question dernier essai
					this.zone_score.SetScore(0, this.zone_question.numquestion);
					this.zone_info.SetInfo(this.zone_info.msg_fde);
					this.zone_info.Show();
					this.rootMovie.corriger();
					this.btn_valider.Hide();
					this.btn_suite.Show();
					this.btn_suite.bouton.onRelease = function() {
						exo.occupe = false;
						exo.rootMovie.gotoAndPlay(3);
						exo.zone_info.Hide();
					};
				}
			} else {
				//C'est la dernière question
				if (this.zone_score.numessai<this.options.max_essais) {
					//C'est la dernière question premier essai
					this.chrono_question.Resume();
					this.zone_info.SetInfo(this.zone_info.msg_fpe);
					this.zone_info.Show();
					this.btn_valider.Show();
					this.zone_score.numessai++;
					this.occupe = false;
					this.zone_question.Active();
				} else {
					//C'est la dernière question dernier essai
					this.chrono_question.Stop();
					this.chrono_question.Hide();
					this.temps=getTimer()-this.temps;
					if (this.chrono != undefined) {
						this.chrono.Stop();
					}
					this.zone_info.SetInfo(this.textes_communs["p3_6"]);
					this.zone_score.SetScore(0, this.zone_question.numquestion);
					this.zone_info.Show();
					this.rootMovie.corriger();
					this.btn_suite.Show();
					this.btn_suite.bouton.onRelease = function() {
						exo.occupe = false;
						exo.btn_suite.Hide();
						exo.zone_info.Hide();
						exo.zone_question.Hide();
						exo.zone_score.Hide();
						if (exo.chrono != undefined) {
							exo.chrono.Hide();
						}
						exo.zone_animation.removeMovieClip();
						//afficher les resultats
						exo.AfficherResultat(exo.zone_score.score, exo.zone_score.score_premier_essai);
						exo.zone_resultat.Show();
						exo.EnregistrerResultat(exo.contexte);
					};
				}
			}
		} else {
			trace("Erreur : la fonction evaluer doit renvoyer \"juste\", \"faux\" ou \"rien\".");
		}
	}
	//
	//Retourne un tableau cle<->valeur
	private  function MettreEnTableau(chaine) {
		var tab_textes = new Array();
		var machaine:String = chaine;
		var echappement = String.fromCharCode(92)+String.fromCharCode(114);
		var LF = String.fromCharCode(10);
		var CR = String.fromCharCode(13);
		var CRLF = String.fromCharCode(13)+String.fromCharCode(10);
		var untab = new Array();
		while (machaine.indexOf(CRLF)<>-1) {
			machaine = remplace(machaine, machaine.indexOf(CRLF), machaine.indexOf(CRLF)+1, LF);
		}
		while (machaine.indexOf(CR)<>-1) {
			machaine = remplace(machaine, machaine.indexOf(CR), machaine.indexOf(CR), LF);
		}
		untab = machaine.split(LF);
		for (var i = 0; i<untab.length; i++) {
			var chcourante:String = untab[i];
			if (chcourante.indexOf("//") != 0) {
				while (chcourante.indexOf(echappement)>-1) {
					chcourante = remplace(chcourante, chcourante.indexOf(echappement), chcourante.indexOf(echappement)+1, String.fromCharCode(13));
				}
				var index = chcourante.substring(0, chcourante.indexOf("="));
				index = supprime_espace(index);
				var valeur = chcourante.substring(chcourante.indexOf("=")+1);
				tab_textes[index] = valeur;
			}
		}
		return tab_textes;
	}
	//remplace des trucs dans une chaine ?
	private  function remplace(s, pos1, pos2, chaine) {
		if ((pos1>0) and (pos2<length(s)-1)) {
			return s.substring(0, pos1)+chaine+s.substring(pos2+1);
		}
		if ((pos1 == 0) and (pos2<length(s)-1)) {
			return chaine+s.substring(pos2+1);
		}
		if ((pos1>0) and (pos2>=length(s)-1)) {
			return s.substring(0, pos1)+chaine;
		}
		if ((pos1<=0) and (pos2>=length(s)-1)) {
			return chaine;
		}
	}
	// retourne une chaine sans CR ?
	private  function supprime_return(chaine) {
		for (var pos = 0; pos<=chaine.length-2; pos++) {
			if ((chaine.charCodeAt(pos)<32)) {
				chaine = chaine.substr(0, pos)+""+chaine.substr(pos+1);
			}
		}
		return chaine;
	}
	//retourne une chaine sans espace
	private  function supprime_espace(chaine) {
		for (var pos = 0; pos<=chaine.length-1; pos++) {
			if ((chaine.charCodeAt(pos) == 32)) {
				chaine = chaine.substr(0, pos)+""+chaine.substr(pos+1);
			}
		}
		return chaine;
	}
	//affiche une appreciation et les resultats
	private  function AfficherResultat(score, score_premier_essai) {
		if (score == this.options.nbre_questions) {
			//tout bon
			var texte_appreciation = this.textes_communs["p4_1"]+"\r";
		} else if (score>this.options.nbre_questions/2) {
			//au dessus de la moyenne
			var texte_appreciation = this.textes_communs["p4_2"]+"\r";
		} else if (score == this.options.nbre_questions/2) {
			//la moyenne
			var texte_appreciation = this.textes_communs["p4_3"]+"\r";
		} else if (score<this.options.nbre_questions/2) {
			//en dessous de la moyenne
			var texte_appreciation = this.textes_communs["p4_4"]+"\r";
		}
		var texte_score = this.textes_communs["p5_4"]+" : "+score+" "+this.textes_communs["p5_3"]+" "+this.options.nbre_questions+"\r\r";
		
		var temps=Math.floor(this.temps/1000);
		var minutes=Math.floor(temps/60);
		var secondes=temps%60;
		if(minutes==1){
			minutes=minutes+" minute ";
		}else {
			minutes = minutes+" minutes ";
		}
		if(secondes==1){
			secondes=secondes+" seconde";
		}else {
			secondes = secondes+" secondes";
		}
		var texte_temps= this.textes_communs["p5_6"]+" : "+minutes+secondes+"\r";
		if(this.options.max_essais>1){
			var texte_premier_essai = this.textes_communs["p5_5"]+" : "+score_premier_essai+"\r\r";
			this.zone_resultat.SetAppreciation(texte_appreciation+texte_score+texte_premier_essai+texte_temps);
		}else{
			this.zone_resultat.SetAppreciation(texte_appreciation+texte_score+texte_temps);
		}
	}
	//
	private  function AfficherRecommencer(){
		var exo=this;
			this.zone_resultat.btn_recommencer.bouton.onRelease = function() {
				exo.occupe = false;
				exo.zone_resultat.Hide();
				exo.rootMovie.gotoAndPlay(2);
			};
			this.zone_resultat.btn_recommencer.Show();
	}
	//
	//enregistre les resultats une fois l'exercice terminé et affiche le bouton "Recommencer" ou "Suivant"
	private  function EnregistrerResultat(sContexte) {
		//la valeur contexte est créé à l'implementation de l'exercice
		//dans la page html 
		var exo=this;
		if (sContexte == undefined 
			|| (sContexte=="appli-calculatice" && this.statut_utilisateur=="prof") 
			|| sContexte == "Air" 
			|| (sContexte=="calculatice-flex" && this.statut_utilisateur=="prof")
			|| (sContexte=="appli-calculatice" && this.statut_utilisateur=="eleve" && save_score=="nosave")
			) {
			//cas d'un exo standalone
			//ou d'un prof qui cree sa séance
			// ou d'un eleve pour lequel on ne veut pas enregistrer les scores
			this.AfficherRecommencer();
		} 
		else {
			//Enregistrement des resultats
			var result_lv:LoadVars = new LoadVars();
			result_lv.onLoad = function(success:Boolean) {
				if (success) {
					//la suite depend du contexte d'implémentation de l'exo
					if(sContexte=="LaboMEP"){
						//routine 2 particulière à mep pour gérer le bouton suivant
					} 
					else if(sContexte=="rallye"){
						//rallye calculatice on affiche le bouton "suivant"
						if(result_lv.enregistrement=="ok"){
							exo.zone_resultat.btn_suivant.Show();
							exo.zone_resultat.btn_suivant.bouton.onRelease = function() {
								//on appelle une fonction javascript qui gère le passage à l'exos suivant
								flash.external.ExternalInterface.call("exo_suivant");
							}
						}
					} 
					else {
						//on affiche les boutons "suivant" et "recommencer"
						if(result_lv.permettre_recommencer=="oui"){
							exo.AfficherRecommencer();
							exo.zone_resultat.btn_recommencer.bouton._x=200;
							exo.zone_resultat.btn_suivant.bouton._x=exo.zone_resultat.btn_recommencer.bouton._x+exo.zone_resultat.btn_recommencer.bouton._width+20;
						}
						if(result_lv.permettre_suivant=="oui"){
							exo.zone_resultat.btn_suivant.Show();
							exo.zone_resultat.btn_suivant.bouton.onRelease = function() {
								if(sContexte=="calculatice-flex"){
									//_parent.unloadMovie();
								}else{
									//on appelle une fonction javascript qui gère le passage à l'exos suivant
									flash.external.ExternalInterface.call("exo_suivant");
									
								}
							}
						}
					}
				} else {
					//l'enregistrement n'a pas fonctionné 
					exo.AfficherRecommencer();
					exo.rootMovie.test_com.text="erreur com serveur";
					//gestion d'erreur de connection à faire
				}
			};
						
			if(sContexte=="LaboMEP"){
				//routine 1 particulière à mep
				var mepData={};
				mepData.uid=this.uid;//identifiant passé dans l'url du flash
				mepData.score=this.zone_score.score;//le score de reussite
				mepData.nbre_questions=this.options.nbre_questions;//le nombre de questions
				mepData.temps=this.temps//le temps mis pour faire l'exercice
				this.ClipMep._level0.commphp(mepData);
				this.AfficherRecommencer();
			}else if (sContexte=="appli-calculatice"){
				var send_lv:LoadVars = new LoadVars();
				send_lv.action="ele_resultat"
				send_lv.action_secondaire="save_score"
				send_lv.id_exo = this.uid;
				send_lv.id_seance = this.seanceid;
				send_lv.nom_exo=this.nom
				send_lv.score_exo = this.zone_score.score;
				send_lv.nbre_questions_exo = this.options.nbre_questions;
				send_lv.contexte_exo=this.contexte;
				send_lv.temps_exo=this.temps;
				send_lv.sendAndLoad("main.php", result_lv, "POST");
			}else if (sContexte=="rallye"){
				var send_lv:LoadVars = new LoadVars();
				send_lv.action="rallye"
				send_lv.action_secondaire="save_score"
				send_lv.id_exo = this.uid;
				//send_lv.id_seance = this.seanceid;
				send_lv.nom_exo=this.nom
				send_lv.score_exo = this.zone_score.score;
				send_lv.nbre_questions_exo = this.options.nbre_questions;
				send_lv.contexte_exo=this.contexte;
				send_lv.temps_exo=this.temps;
				send_lv.sendAndLoad("main.php", result_lv, "POST");
			}
		}
	}
	//
	private  function LoadOptions(sContexte, options) {
		if (sContexte == undefined) {
			this.SetDefaultOptions(options);
			this.rootMovie.gotoAndPlay(2);
			trace("flash standalone");
		} else if (sContexte == "appli-calculatice" || sContexte == "calculatice-flex") {
			var json = new JSON();
			var sOptions=String(flash.external.ExternalInterface.call("charger_options"));
			if(sOptions=="default"){
				this.SetDefaultOptions(options);
			}else{
				this.options = json.parse(sOptions);
			}
			this.rootMovie.gotoAndPlay(2);
		} else if (sContexte == "LaboMEP") {
			this.SetDefaultOptions(options);
			var sOptions=String(flash.external.ExternalInterface.call("loadOptionsToFlash"));
			if(sOptions=="default"){
				this.SetDefaultOptions(options);
			}else{
				var json = new JSON();
				this.options = json.parse(sOptions);
			}
			this.rootMovie.gotoAndPlay(2);
		} else if (sContexte == "Air"){
			var sOptions=String(this.rootMovie.options_air);
			if(this.rootMovie.options_air=="default"){
				this.SetDefaultOptions(options);
				this.rootMovie.gotoAndPlay(2);
			}else{
				var json = new JSON();
				this.options=json.parse(this.rootMovie.options_air);
				this.rootMovie.gotoAndPlay(2);
			}
			
		} else{
			//contexte=site web spip
			this.SetDefaultOptions(options);
			this.rootMovie.gotoAndPlay(2);
		}
	}
	//
	private  function EnregistrerOptions(sContexte) {
		//flash.external.ExternalInterface.call("alerter", sContexte);
		if (sContexte == undefined) {
			this.btn_tester_options.Show();
		} else if (sContexte == "LaboMEP") {
			var json = new JSON();
			var sParams = json.stringify(this.options);
			return sParams;
			//flash.external.ExternalInterface.call("getOptionsFromFlash", sParams);
			//this.btn_tester_options.Show();
			
		} else if (sContexte == "appli-calculatice" || sContexte=="calculatice-flex") {
			var json = new JSON();
			var sParams = json.stringify(this.options);
			//var sParams = this.options.toString();
			flash.external.ExternalInterface.call("enregistrer_options", sParams);
			this.btn_tester_options.Show();
		}else if (sContexte == "Air") {
			var json = new JSON();
			var sParams = json.stringify(this.options);
			flash.external.ExternalInterface.call("recOptions",sParams);
			this.btn_tester_options.Show();
		}
		//si contexte =site web spip pas d'enregistrement des options
	}
	//
	private  function EnregistrerOptionsPourMep() {
		for (var i = 0; i<this.zone_options.controles_option.length; i++) {
			var controle = this.zone_options.controles_option[i];
			this.options[controle.nom] = controle.GetValeur();
		}
		var json = new JSON();
		var sParams = json.stringify(this.options);
		flash.external.ExternalInterface.call("getOptionsFromFlash", sParams);
	}
	//
	private  function rewind(){
		if(this.rootMovie._currentframe==4){
			this.Avancer("temps_depasse");
			this.occupe = false;
			this.btn_suite.Hide();
			this.zone_info.Hide();
			this.zone_question.Hide();
			this.zone_score.Hide();
			if (this.chrono != undefined) {
				this.chrono.Hide();
			}
			this.zone_animation.removeMovieClip();
			this.rootMovie.gotoAndStop(2);
		}else if(this.rootMovie._currentframe==5){
			this.zone_options.Hide();
			this.btn_valider_options.Hide();
			this.btn_tester_options.Hide();
			this.rootMovie.gotoAndStop(2);
		}
	}
	
}