﻿class OptionRadio {
	private var cadre_radio:MovieClip;
	private var cadre_x:Number;
	private var cadre_y:Number;
	private var cadre_largeur:Number;
	private var aTextes:Array;
	private var aValeurs:Array;
	public var aBoutonsRadio:Array;
	private var aLabelsRadio:Array;
	private var valeur;
	private var nom:String;
	private var orientatio:String;
	//public function OptionRadio(sNom:String, cadre_x:Number, cadre_y:Number, cadre_largeur:Number) {
	public function OptionRadio(mc_conteneur:MovieClip, nom:String,sOrientation:String) {
		this.cadre_radio = mc_conteneur.createEmptyMovieClip(nom, mc_conteneur.getNextHighestDepth());
		this.nom = nom;
		if(sOrientation==undefined){
			this.orientatio="horizontale";
		}else {
			this.orientatio=sOrientation;
		}
	}
	public function AjouteBoutons(aTextes:Array, aValeurs:Array) {
		this.aTextes = aTextes;
		this.aValeurs = aValeurs;
		this.aBoutonsRadio = new Array();
		this.aLabelsRadio = new Array();
		for (var i = 0; i<aTextes.length; i++) {
			this.aBoutonsRadio[i] = this.cadre_radio.attachMovie("bouton_radio", "btn_radio_"+i, this.cadre_radio.getNextHighestDepth());
			this.aBoutonsRadio[i].checked = false;
			this.aBoutonsRadio[i].valeur = aValeurs[i];
			this.aLabelsRadio[i] = this.cadre_radio.createTextField("lbl_radio_"+i, this.cadre_radio.getNextHighestDepth(), this.aBoutonsRadio[i]._width+2, 0, 0, 0);
			this.aLabelsRadio[i].embedFonts=true;
			this.aLabelsRadio[i].antiAliasType = "advanced";
			this.aLabelsRadio[i].text = aTextes[i];
			var fmt = new TextFormat();
			fmt.size = 14;
			fmt.bold = false;
			fmt.font = "emb_tahoma";
			this.aLabelsRadio[i].setTextFormat(fmt);
			this.aLabelsRadio[i].autoSize = true;
		}
		if(orientatio=="horizontale"){
			for (var i = 1; i<this.aBoutonsRadio.length; i++) {
				this.aBoutonsRadio[i]._x = this.aLabelsRadio[i-1]._x+this.aLabelsRadio[i-1]._width+20;
				this.aLabelsRadio[i]._x = this.aBoutonsRadio[i]._x+this.aBoutonsRadio[i]._width+2;
			}
		} else if(orientatio=="verticale") {
			for (var i = 1; i<this.aBoutonsRadio.length; i++) {
				this.aBoutonsRadio[i]._y = this.aLabelsRadio[i-1]._y+20;
				this.aLabelsRadio[i]._x = this.aBoutonsRadio[i]._x+this.aBoutonsRadio[i]._width+2;
				this.aLabelsRadio[i]._y = this.aBoutonsRadio[i]._y;
			}
		}
		for (var i = 0; i<this.aBoutonsRadio.length; i++) {
			var objGroupeRadio = this;
			AsBroadcaster.initialize(this.aBoutonsRadio[i]);
			this.aBoutonsRadio[i].onPress = function() {
				if (this.checked == false) {
					for (var j = 0; j<objGroupeRadio.aBoutonsRadio.length; j++) {
						objGroupeRadio.aBoutonsRadio[j].checked = false;
						objGroupeRadio.aBoutonsRadio[j].gotoAndStop(1);
					}
					this.checked = true;
					this.gotoAndStop(2);
					objGroupeRadio.valeur = this.valeur;
				}
				//on genere un evt onClick qui pourra etre récupéré
				this.broadcastMessage("onClick");
			};
		}
	}
	public function SetPos(pos_x:Number, pos_y:Number) {
		this.cadre_radio._x = pos_x;
		this.cadre_radio._y = pos_y;
	}
	public function SetValeur(nValeurBouton:String) {
		for (var j = 0; j<this.aBoutonsRadio.length; j++) {
			if (this.aBoutonsRadio[j].valeur == nValeurBouton) {
				this.valeur = nValeurBouton;
				this.aBoutonsRadio[j].checked = true;
				this.aBoutonsRadio[j].gotoAndStop(2);
			} else {
				this.aBoutonsRadio[j].checked = false;
				this.aBoutonsRadio[j].gotoAndStop(1);
			}
		}
	}
	public function GetValeur() {
		if (isNaN(this.valeur)) {
			return this.valeur;
		} else {
			return parseInt(this.valeur);
		}
	}
	public function Hide(nBouton)
	{
		trace("Hide:  btn_radio_"+nBouton);
		this.cadre_radio["btn_radio_"+nBouton]._visible = false;
		this.cadre_radio["lbl_radio_"+nBouton]._visible = false;
	}
	
	public function Show(nBouton)
	{
		trace("Show: btn_radio_"+nBouton);
		this.cadre_radio["btn_radio_"+nBouton]._visible = true;
		this.cadre_radio["lbl_radio_"+nBouton]._visible = true;
	}
	
}
