var CLC = (function(clc) {
//Ne pas oublier de renommer ci-dessous clc.xxxxx par clc.nom-de-votre-exercice
clc.train = function(oOptions,path){
//
var exo = clc.exoBase(path);
var util = clc.utils;//raccourci
var disp = clc.display;//raccourci
var anim = clc.animation;//raccourci
    
// Déclarer ici les variables globales à l'exercice.
//donnees est un tableau contenant nb de wagons, vitesse des wagons, nb dans les wagons et opérateur
var donnees = new Array();
var vitesses = [55,54,50,50,48,46,44,44,42,42]; //N'est pas utilisé pour l'instant : une seule vitesse, paramétrée dans les options
var nbWagons = new Array();//N'est pas utilisé pour l'instant : 3 wagons à chaque fois
var complement = [10,10,10,10,10,10,20,20,20,20];//Compléments travaillés (ici, 6 questions sur 10, et 4 sur 20)
var nb1, nb2, nb3, nb4;//Nombres posés sur wagons
//var vop1, vop2, vop3, vop4, solutionNb, aleatNb;
//récupération du type de calcul
//variables d'affichage :
var rails, locomotive, wagon, etiquette, etiquetteoperateur, etiquettequestion, zoneReponse;
var repEleve, animfinie;//animfinie nous indique si le train est sorti de l'écran ou non (1 si oui)

// ex : var repEleve, soluce, champReponse, arNombre;
exo.oRessources = {
	txt:"train/textes/train_fr.json",
    //illustration : "monexo/images/illustration.png"
	illustration:"train/images/Illustration.png",
	locomotive:"train/images/Locomotive.png",
	rails:"train/images/rails.jpg",
	wagon:"train/images/Wagon.png",
	bouleTransparente:"train/images/BouleTranparente.png",
	bouleOrange:"train/images/BouleOrange.png",
	bouleBleue:"train/images/BouleBleue.png",
	bouleVerte:"train/images/BouleVerte.png"
}

// Options par défaut de l'exercice (définir au moins totalQuestion et tempsExo )

exo.creerOptions = function() {
    var optionsParDefaut = {
        totalQuestion:10,
		vitesseTrain:8000,
		totalEssai:1,
		niveau:2,
		operateur:1,	
    }
    $.extend(exo.options,optionsParDefaut,oOptions);
}

// Création des données de l'exercice (peut rester vide), exécutée a chaque fois que l'on commence ou recommence l'exercice

exo.creerDonnees = function() {
    //On commence par le nombre de wagons par questions (non utilisé pour l'instant)
    if(exo.options.niveau==0){
        nbWagons = [2,2,2,2,2,2,2,2,2,2];
    }
    if(exo.options.niveau==1){
        nbWagons = [2,2,2,2,2,2,2,2,3,3];
    }
    if(exo.options.niveau==2){
        nbWagons = [3,3,3,3,3,3,3,3,3,3];
    }
    if(exo.options.niveau==3){
        nbWagons = [3,3,3,3,3,3,3,3,4,4];
    }
//De Q1 à Q10, on remplit le tableau donnees
    var nbQuestions = exo.options.totalQuestion;
    var q;//Indice question
	switch (exo.options.operateur){
		case 1://Addition
			var operateur = "+";
			break;
		case 2://Multiplication
			var operateur = "x";
			break;
	}
    for(q=0;q<nbQuestions;q++){
        //On va de question en question
        var min, max;
        min = 1;//Nombre minimum
        max = complement[q] - min;//Nombre maximum (on évite le 0)
        nb1=min + Math.floor(Math.random()*(max - min + 1));//
        nb2=Math.floor(Math.random()*10)+1;//On ajoute 1 pour éviter 0
        nb3=complement[q] - nb1;
        //nb1 et nb3 forment le complément
        if (q%3==0) {
			donnees[q] = {
				nbWagons:nbWagons[q],//Stocké, mais inutilisé
				vitesse:vitesses[q],//Stocké, mais inutilisé
				op:operateur,
				valeurs:{
				    0:nb1,
				    1:nb2,
				    2:nb3
				},
				boulesOranges:{
					0:1,
					1:0,
					2:1
				},
				solution:nb1+nb2+nb3
			};
		} else if(q%3==1) {
			donnees[q] = {
				nbWagons:nbWagons[q],//Stocké, mais inutilisé
				vitesse:vitesses[q],//Stocké, mais inutilisé
				op:operateur,
				valeurs:{
				    0:nb1,
				    1:nb3,
				    2:nb2
				},
				boulesOranges:{
					0:1,
					1:1,
					2:0
				},
				solution:nb1+nb2+nb3
			};
		} else {
			donnees[q] = {
				nbWagons:nbWagons[q],//Stocké, mais inutilisé
				vitesse:vitesses[q],//Stocké, mais inutilisé
				op:operateur,
				valeurs:{
				    0:nb2,
				    1:nb1,
				    2:nb3
				},
				boulesOranges:{
					0:0,
					1:1,
					2:1
				},
				solution:nb1+nb2+nb3
			};
		}
        
    }
}
//Création de la page titre : 3 éléments exo.blocTitre, exo.blocConsigneGenerale, exo.blocIllustration

exo.creerPageTitre = function() {
    exo.blocTitre.html(exo.txt.titre);
    exo.blocConsigneGenerale.html(exo.txt.consigneGenerale);
    var illustration = disp.createImageSprite(exo,"illustration");
    exo.blocIllustration.html(illustration)    
}

//Création de la page question, exécutée à chaque question, tous les éléments de la page doivent être ajoutés à exo.blocAnimation

exo.creerPageQuestion = function() {
    var q = exo.indiceQuestion;

	exo.keyboard.config({
		numeric:"enabled",
		arrow:"disabled",
		large:"enabled",
	});

    repEleve = "";//On vide repEleve, pour éviter qu'elle ne reste remplie d'une réponse à l'autre
    animfinie=0;//Le train n'est pas encore sorti de l'écran
    rails = disp.createImageSprite(exo,"rails");//rails
    exo.blocAnimation.append(rails);
    rails.position({
        my:'center',
        at:'center',
        of:exo.blocAnimation
    });
    
    locomotive = disp.createImageSprite(exo,"locomotive");//locomotive
    rails.append(locomotive);
    locomotive.position({
        my:'center',
        at:'center+75 center-30',
        of:rails
    });
    
    //Wagons
    var nbreWagons, posat, positionat;//posat est la valeur du décallage, positionat est la chaîne à mettre à côté du at:
    nbreWagons = donnees[q].nbWagons;
    wagon=[];
    etiquette=[];
    etiquetteoperateur=[];//initialisation des tableaux (sinon plantage)
    for(i=0;i<nbreWagons;i++) {
        wagon[i] = disp.createImageSprite(exo,"wagon");
        locomotive.append(wagon[i]);//Les Wagons appartiennent à la locomotive (et non à exo.blocAnimation
        //Lorsqu'on déplace la locomotive, les wagons bougent aussi
        posat = 100 + 70 * i;//On décale chaque wagon de 70 pixels - Le 100 est le décalage initial par rapport à la locomotive
        positionat = "center+" + posat + " bottom";//Création de la chaîne
        wagon[i].position({my:'center bottom',at:positionat,of:locomotive});//Placement selon position calculée
        etiquette[i] = disp.createTextLabel(donnees[q].valeurs[i]);//Les étiquettes sont remplies avec les valeurs du tableau donnees
        wagon[i].append(etiquette[i]);//Chaque wagon a son étiquette, qui bouge avec lui
        etiquette[i].position({
            my:'center',
            at:'center center-35',
            of:wagon[i]
        })//Elles sont placées 35 px au dessus de leur wagon
        if (i<(nbreWagons-1)) {//Pour éviter de rajouter un signe après le dernier wagon
            etiquetteoperateur[i] = disp.createTextLabel("+");//donnees[q].operateur);
            etiquette[i].append(etiquetteoperateur[i]);
            etiquetteoperateur[i].position({
                my:'center',
                at:'center+35 center',
                of:etiquette[i]
            })//chaque opérateur appartient à l'étiquette nombre qui le précède, et est placé 35px sur sa droite
        }
        
    }
    etiquettequestion = "";//Initialisation des vars d'énoncé, et de la zoneréponse
    zoneReponse = "";
    etiquettequestion = disp.createTextLabel(exo.txt.consigne1);
    exo.blocAnimation.append(etiquettequestion);
    etiquettequestion.position({
        my:'center center',
        at:'center center-150',
        of:exo.blocAnimation
    })//On place l'énoncé 150px au dessus du centre de l'exo
    zoneReponse = disp.createTextField(4);
    exo.blocAnimation.append(zoneReponse);
    zoneReponse.position({
        my:'center center',
        at:'center center+50',
        of:exo.blocAnimation
    })//On place la zone de saisie 50 px en dessous de la moitié de l'exo
	zoneReponse.focus();
	locomotive.transition({x:-735},exo.options.vitesseTrain,'linear',finAnim);
    //anim.translate(locomotive,-250,0,0,exo.options.vitesseTrain,'linear',finAnim);
    //On utilise anim.translate pour pouvoir arrêter la translation
    //On exécute finAnim si le train sort complètement de l'écran
    function finAnim() {
        
/*********        var tempsEcoule;
        tempsEcoule = disp.createTextLabel("Temps écoulé !");
        exo.blocAnimation.append(tempsEcoule);
        tempsEcoule.position({
            my:'center center',
            at:'center center-80',
            of:exo.blocAnimation
        })//On affiche une étiquette en rouge
        tempsEcoule.css({
            color:'red'
        })
        **************/
console.log("La fonction s'exécute");
        animfinie=1;//On passe animfinie à 1 pour gérer ce cas lors de l'évaluation
        exo.avancer();//On passe à l'éval
    }

}
    

// Evaluation doit toujours retourner "juste" "faux" ou "rien"


exo.evaluer = function() {
console.log("Début Evaluer");
        if (animfinie==1) {
            return "faux";
        }
	repEleve = zoneReponse.val();
        if (repEleve == "") { 
		return "rien";
	}
	else if (repEleve == donnees[exo.indiceQuestion].solution) {
            //anim.translateStop(locomotive);
			locomotive.transitionStop();
            return "juste";
	} else {
            //anim.translateStop(locomotive);
			locomotive.transitionStop();
            return "faux";
	}
}

// Correction (peut rester vide)

exo.corriger = function() {
    var q = exo.indiceQuestion;
	var boules;
    var nombres, etiquetteCor, signes, etiquetteCorSigne;
	exo.cacherBtnSuite();

    if (animfinie==0) { 
        var barre;
        barre = disp.drawBar(zoneReponse);
        exo.blocAnimation.append(barre);//On barre la zone de saisie avec la valeur fausse
    }
	
    var posmy,positionmy;
    /**********************
	 * Variables :
	 *  - posmy : calcule la valeur numérique qui permet de décaler chaque étiquette
	 *  - positionmy : Texte incluant posmy pour la fonction .position();
	 *  - nombres : tableau des nombres à afficher
	 *  - signes : tableau des signes à afficher (dépend des options)
	 *  - etiquetteCor : tableau des étiquettes qui permettent d'afficher les nombres
	 *  - etiquetteCorSigne : tableau des étiquettes qui permettent d'afficher les signes
	 *  - boulesTransparentes : tableau stockant les sprites transparents qui permettent d'affiche les étiquettes
	 *  - boulesOranges, boulesVertes et boulesBleues : tableau stockant les boules qui mettent en exergue la simplification
	 *********************/
	    
    nombres = [];
    signes = [];
    etiquetteCor = [];
	boulesTransparentes = [];
	boulesOranges = [];
	boulesVertes = [];
	boulesBleues = [];
    etiquetteCorSigne = [];//Initialisation des tableaux (sinon, plantage)
    nombres[0] = donnees[q].valeurs[0];
    nombres[1] = donnees[q].valeurs[1];
    nombres[2] = donnees[q].valeurs[2];
    signes[0] = donnees[q].op;
    signes[1] = donnees[q].op;
    signes[2] = "";
    //On remplit les tableaux, pour générer les étiquettes correction
    
	var animCorrection;
	animCorrection = anim.creerDemon(boules,animerA,1200,7);
	animCorrection.start();
	
	function animerA(etape) {
		//this renvoit à boules (le premier paramètre)
		//ex : this[0] me renvoit le premier élément du tableau boules
		//On stoppe le démon avec animCorrection.pause();
		if (etape==1) {
			for(i=0;i<3;i++){
				boulesTransparentes[i] = disp.createImageSprite(exo,"bouleTransparente");
				exo.blocAnimation.append(boulesTransparentes[i]);
				posmy = 15 + (i*50);
				positionmy = 'left+'+posmy+' center+40';
				boulesTransparentes[i].position({my:positionmy,at:'left center',of:exo.blocAnimation});
				boulesOranges[i] = disp.createImageSprite(exo,"bouleOrange");
				boulesTransparentes[i].append(boulesOranges[i]);
				boulesOranges[i].position({my:'center',at:'center',of:boulesTransparentes[i]});
				boulesOranges[i].hide();
				
				boulesVertes[i] = disp.createImageSprite(exo,"bouleVerte");
				boulesTransparentes[i].append(boulesVertes[i]);
				boulesVertes[i].position({my:'center',at:'center',of:boulesTransparentes[i]});
				boulesVertes[i].hide();
				
				//On place chaque nombre, avec un décalage de 50 px par rapport au précédant, et 40 px en dessous des rails
				
				etiquetteCor[i] = disp.createTextLabel(nombres[i]);
				boulesTransparentes[i].append(etiquetteCor[i]);
				etiquetteCor[i].position({my:'center',at:'center',of:boulesTransparentes[i]});
				//On place chaque nombre, avec un décalage de 50 px par rapport au précédant, et 40 px en dessous des rails
				
				etiquetteCorSigne[i] = disp.createTextLabel(signes[i]);
				exo.blocAnimation.append(etiquetteCorSigne[i]);
				etiquetteCorSigne[i].position({my:'center+25 center', at:'center center', of:etiquetteCor[i]});
				//On place chaque opérateur 25 px après chaque nombre. Le dernier opérateur est une chaîne vide, car chaque opérateur est ajouté à droite du nombre
				//Or, il y a un opérateur en moins que le nombre de termes de l'opération
			}
		} else if (etape==2) {
			if (donnees[q].boulesOranges[0]==1) {
				boulesOranges[0].show();
			} else {
				boulesVertes[0].show();
			}
		} else if (etape==3) {
			if (donnees[q].boulesOranges[1]==1) {
				boulesOranges[1].show();
			} else {
				boulesVertes[1].show();
			}
		} else if (etape==4) {
			if (donnees[q].boulesOranges[2]==1) {
				boulesOranges[2].show();
			} else {
				boulesVertes[2].show();
			}
		} else if (etape==5) {
			nombres = [];
			signes = [];
			etiquetteCor = [];
			boulesTransparentes = [];
			boulesOranges = [];
			boulesBleues = [];
			etiquetteCorSigne = [];//Initialisation des tableaux (sinon, plantage)
			if (donnees[q].boulesOranges[0]==0) {
				nombres[0] = donnees[q].valeurs[1];
				nombres[1] = donnees[q].valeurs[2];
				nombres[2] = donnees[q].valeurs[1] + donnees[q].valeurs[2];//Simplification
			} else if (donnees[q].boulesOranges[1]==0) {
				nombres[0] = donnees[q].valeurs[0];
				nombres[1] = donnees[q].valeurs[2];
				nombres[2] = donnees[q].valeurs[0] + donnees[q].valeurs[2];//Simplification
			} else {
				nombres[0] = donnees[q].valeurs[0];
				nombres[1] = donnees[q].valeurs[1];
				nombres[2] = donnees[q].valeurs[0] + donnees[q].valeurs[1];//Simplification
				
			}
			signes[0] = donnees[q].op;
			signes[1] = "=";
			signes[2] = "";
			
			for(i=0;i<3;i++){
				boulesTransparentes[i] = disp.createImageSprite(exo,"bouleTransparente");
				exo.blocAnimation.append(boulesTransparentes[i]);
				posmy = 15 + (i*50);
				positionmy = 'left+'+posmy+' center+80';
				boulesTransparentes[i].position({my:positionmy,at:'left center',of:exo.blocAnimation});
				boulesOranges[i] = disp.createImageSprite(exo,"bouleOrange");
				boulesTransparentes[i].append(boulesOranges[i]);
				boulesOranges[i].position({my:'center',at:'center',of:boulesTransparentes[i]});

				boulesBleues[i] = disp.createImageSprite(exo,"bouleBleue");
				boulesTransparentes[i].append(boulesBleues[i]);
				boulesBleues[i].position({my:'center',at:'center',of:boulesTransparentes[i]});
				boulesBleues[i].hide();
				if (i==2) {
						boulesOranges[i].hide();
				}

				etiquetteCor[i] = disp.createTextLabel(nombres[i]);
				exo.blocAnimation.append(etiquetteCor[i]);
				etiquetteCor[i].position({my:'center',at:'center',of:boulesTransparentes[i]});
				//On est 80 px en dessous des rails
				
				etiquetteCorSigne[i] = disp.createTextLabel(signes[i]);
				exo.blocAnimation.append(etiquetteCorSigne[i]);
				etiquetteCorSigne[i].position({my:'center+25 center', at:'center center', of:etiquetteCor[i]});        
			}
			
			
		} else if (etape==6) {
			boulesBleues[2].show();
		} else if (etape==7) {
			nombres = [];
			signes = [];
			etiquetteCor = [];
			etiquetteCorSigne = [];
			if (donnees[q].boulesOranges[0]==0) {
				nombres[0] = donnees[q].valeurs[1] + donnees[q].valeurs[2];//Simplification
				nombres[1] = donnees[q].valeurs[0];
			} else if (donnees[q].boulesOranges[1]==0) {
				nombres[0] = donnees[q].valeurs[0] + donnees[q].valeurs[2];//Simplification
				nombres[1] = donnees[q].valeurs[1];
			} else {
				nombres[0] = donnees[q].valeurs[0] + donnees[q].valeurs[1];//Simplification
				nombres[1] = donnees[q].valeurs[2];
				
			}
			
			nombres[2] = donnees[q].solution;
			signes[0] = donnees[q].op;
			signes[1] = "=";
			signes[2] = "";
		 	boulesVertes = [];
			boulesBleues = [];
			boulesTransparentes = [];
   
			for(i=0;i<3;i++){
				boulesTransparentes[i] = disp.createImageSprite(exo,"bouleTransparente");
				exo.blocAnimation.append(boulesTransparentes[i]);
				posmy = 15 + (i*50);
				positionmy = 'left+'+posmy+' center+120';
				boulesTransparentes[i].position({my:positionmy,at:'left center',of:exo.blocAnimation});
				boulesVertes[i] = disp.createImageSprite(exo,"bouleVerte");
				boulesTransparentes[i].append(boulesVertes[i]);
				boulesVertes[i].position({my:'center',at:'center',of:boulesTransparentes[i]});
				boulesVertes[i].hide();

				boulesBleues[i] = disp.createImageSprite(exo,"bouleBleue");
				boulesTransparentes[i].append(boulesBleues[i]);
				boulesBleues[i].position({my:'center',at:'center',of:boulesTransparentes[i]});
				boulesBleues[i].hide();

				if (i==0) {
						boulesBleues[i].show();
				} else if (i==1) {
						boulesVertes[i].show();
				}
				

				etiquetteCor[i] = disp.createTextLabel(nombres[i]);
				exo.blocAnimation.append(etiquetteCor[i]);
				etiquetteCor[i].position({my:'center',at:'center',of:boulesTransparentes[i]});
				//On est 80 px en dessous des rails
				
				etiquetteCorSigne[i] = disp.createTextLabel(signes[i]);
				exo.blocAnimation.append(etiquetteCorSigne[i]);
				etiquetteCorSigne[i].position({my:'center+25 center', at:'center center', of:etiquetteCor[i]});        
						}
			exo.afficherBtnSuite();
		}
        
    }
}

// Création des contrôles permettant au prof de paraméter l'exo

exo.creerPageParametre = function() {
    var controle = disp.createOptControl(exo,{
        type:"text",
        largeur:24,
        taille:2,
        nom:"totalQuestion",
        texte:exo.txt.option1
    });
    exo.blocParametre.append(controle);
    //
    var controle = disp.createOptControl(exo,{
        type:"text",
        largeur:48,
        taille:6,
        nom:"vitesseTrain",
        texte:exo.txt.option2
    });
    exo.blocParametre.append(controle);
/*    var controle = disp.createOptControl(exo,{
        type:"text",
        largeur:24,
        taille:3,
        nom:"niveau",
        texte:exo.txt.option3
    });
    exo.blocParametre.append(controle);*/
    
}

/********************
*   C'est fini
*********************/
exo.init();
return exo.baseContainer;
}
return clc;
}(CLC))